/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
#include <qdom.h>
#include <qdir.h>
#include <qmessagebox.h>
#include <qtextcodec.h>
#include <qsettings.h>
#include "version.h"


QStringList listaFirmy;

QStringList listaUrzedy;

void
kontList::init ()
{
  QSettings settings;
  QString localEnc = settings.readEntry ("elinux/localEnc", "ISO 8859-2");
  QTextCodec::setCodecForCStrings (QTextCodec::codecForName (localEnc));
  QTextCodec::setCodecForTr (QTextCodec::codecForName (localEnc));
  QTextCodec::setCodecForLocale (QTextCodec::codecForName (localEnc));
  settings.beginGroup ("elinux/formatki");
  this->setGeometry(settings.readEntry ("kontlist_left").toInt(),
		  settings.readEntry ("kontlist_top").toInt(),
		  settings.readEntry ("kontlist_width").toInt(), 
  	                  settings.readEntry ("kontlist_height").toInt());

  settings.endGroup();
  QDir tmp;
  QString progDir = tmp.homeDirPath () + "/elinux";
  listaFirmy.clear ();
  listaUrzedy.clear ();
  readKontr (progDir);
  fillFirmy();
   listBox1->setCurrentItem(0);
}



void
kontList::readKontr (QString progDir)
{
  QDomDocument doc ("kontrahenci");
  QDomElement root;
  QDomElement urzad;
  QDomElement firma;

  QFile file (progDir + "/kontrah.xml");
  if (!file.open (IO_ReadOnly))
    {
      qDebug ("file doesn't exists");
      return;

    }
  else
    {
      QTextStream stream (&file);
      if (!doc.setContent (stream.read ()))
	{
	  qDebug ("can not set content ");
	  file.close ();
	  return;
	}
      else
	{
	  root = doc.documentElement ();
	  urzad = root.firstChild ().toElement ();
	  firma = root.lastChild ().toElement ();
	}
      QString text;

      for (QDomNode n = firma.firstChild (); !n.isNull ();
	   n = n.nextSibling ())
	{

	  text = n.toElement ().attribute ("name");
	  text += ", " + n.toElement ().attribute ("code");
	  text += " " + n.toElement ().attribute ("place");
	  text += ", " + n.toElement ().attribute ("address");	// ul. 
	  text += ", " + n.toElement ().attribute ("nip");
	  text += ", " + n.toElement ().attribute ("account");
	  text += ", " + n.toElement ().attribute ("telefon");
	  text += ", " + n.toElement ().attribute ("email");
	  text += ", " + n.toElement ().attribute ("www");	  
	  listaFirmy.append (text);
	}

      for (QDomNode n = urzad.firstChild (); !n.isNull ();
	   n = n.nextSibling ())
	{

	  text = n.toElement ().attribute ("name");
	  text += ", " + n.toElement ().attribute ("code");
	  text += " " + n.toElement ().attribute ("place");
	  text += ", " + n.toElement ().attribute ("address");	// ul. 
	  text += ", " + n.toElement ().attribute ("nip");
	  text += ", " + n.toElement ().attribute ("account");
	  text += ", " + n.toElement ().attribute ("telefon");
	  text += ", " + n.toElement ().attribute ("email");
	  text += ", " + n.toElement ().attribute ("www");	
	  listaUrzedy.append (text);
	}
    }
}


void
kontList::doAccept ()
{
    QSettings settings;
  int selNr, posCount = listBox1->count ();
  bool hasSel = false;
  for (selNr = 0; selNr < posCount; ++selNr)
    {
      if (listBox1->isSelected (selNr))
	{
	  hasSel = true;
	  break;
	}
    }

  if (hasSel)
    {

      {
	    switch (comboBox1->currentItem ())
    {
    case 0:
	      ret = listaFirmy[listBox1->currentItem()];
      break;
    case 1:

	      ret = listaUrzedy[listBox1->currentItem()];	      
	      break;
    }
      }
    settings.beginGroup ("elinux/formatki");
    settings.writeEntry ("kontlist_top",QString::number(this->y()));
    settings.writeEntry ("kontlist_left",QString::number(this->x()));
    settings.writeEntry ("kontlist_width",QString::number(this->width()));
    settings.writeEntry ("kontlist_height",QString::number(this->height()));
    settings.endGroup ();
      accept ();
    }
  else
    {
      QMessageBox::information (this, "QFaktury", tr("Wska kontrahenta."),
				QMessageBox::Ok);
    }
}

void
kontList::comboBox1Changed ()
{

  switch (comboBox1->currentItem ())
    {
    case 0:
	fillFirmy();
	if(listaFirmy.size()==0)
	{
  	  lblName->setText("");
	  lblAddress->setText("");
	  lblPlace->setText("");
	  lblNip->setText("");
	  lblAccount->setText("");
	  lblPhone->setText("");
	  lblEmail->setText("");
	  lblWww->setText("");	    
	}
      break;
    case 1:
	fillUrzedy();
	if(listaUrzedy.size()==0)
	{
  	  lblName->setText("");
	  lblAddress->setText("");
	  lblPlace->setText("");
	  lblNip->setText("");
	  lblAccount->setText("");
	  lblPhone->setText("");
	  lblEmail->setText("");
	  lblWww->setText("");	    
	}	
      break;
    }
}


void kontList::closeEvent( QCloseEvent * e )
{
    QSettings settings;
    settings.beginGroup ("elinux/formatki");
    settings.writeEntry ("kontlist_top",QString::number(this->y()));
    settings.writeEntry ("kontlist_left",QString::number(this->x()));
    settings.writeEntry ("kontlist_width",QString::number(this->width()));
    settings.writeEntry ("kontlist_height",QString::number(this->height()));
    settings.endGroup ();
       e->accept ();
}


void kontList::fillFirmy()
{
    listBox1->clear();
    QStringList temp;
    for(unsigned int i=0;i<listaFirmy.size();++i)
    {
	temp=QStringList::split(",",listaFirmy[i]);
	listBox1->insertItem(temp[0]);
        }
}


void kontList::fillUrzedy()
{
    listBox1->clear();    
    QStringList temp;
    for(unsigned int i=0;i<listaUrzedy.size();++i)
    {
	temp=QStringList::split(",",listaUrzedy[i]);
	listBox1->insertItem(temp[0]);
    }
}


void kontList::details( int i )
{
    QStringList temp;
  switch (comboBox1->currentItem ())
    {
    case 0:
	temp=QStringList::split(",",listaFirmy[i]);
      break;
    case 1:
	temp=QStringList::split(",",listaUrzedy[i]);
      break;
    }

  
  	  lblName->setText(temp[0]);
	  lblAddress->setText(temp[1]);
	  lblPlace->setText(temp[2]);
	  lblNip->setText(temp[3]);
	  lblAccount->setText(temp[4]);
	  lblPhone->setText(temp[5]);
	  lblEmail->setText(temp[6]);
	  lblWww->setText(temp[7]);
}
