/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
#include <qtextcodec.h>
#include <qsettings.h>
#include <qdom.h>
#include "config.h"
#include "tabletemp.h"
#include "zaokr.h"
#include "chamount.h"
#include "slownie.h"
#include "version.h"



void PrintPreview::scroolChanged( int)
{
    label->setPixmap(pixmap[pagespinbox->value()-1]);
}
#include <qpainter.h>
#include <qsettings.h>
void PrintPreview::init()
{
    QSettings settings;

    QString localEnc = settings.readEntry ("elinux/localEnc", "ISO 8859-2");
    QTextCodec::setCodecForCStrings (QTextCodec::codecForName (localEnc));
    QTextCodec::setCodecForTr (QTextCodec::codecForName (localEnc));
    QTextCodec::setCodecForLocale (QTextCodec::codecForName (localEnc));
    settings.beginGroup ("elinux/formatki");
    this->setGeometry(settings.readEntry ("printpreview_left").toInt(),
		  settings.readEntry ("printpreview_top").toInt(),
		  settings.readEntry ("printpreview_width").toInt(), 
  	                  settings.readEntry ("printpreview_height").toInt());

    settings.endGroup();   
    scale=1;
    makePdf=false;    
    margTop=settings.readEntry ("elinux/faktury/margTopPrinter").toInt()*4;
    margLeft=settings.readEntry ("elinux/faktury/margLeftPrinter").toInt()*4;
    margRight=settings.readEntry ("elinux/faktury/margRightPrinter").toInt()*4;
    margDown=settings.readEntry ("elinux/faktury/margDownPrinter").toInt()*4;
    pageMargTop=static_cast<double>(settings.readEntry ("elinux/faktury/margTopPrinter").toInt()*4);
    pageMargLeft=static_cast<double>(settings.readEntry ("elinux/faktury/margLeftPrinter").toInt()*4);
    pageMargRight=static_cast<double>(settings.readEntry ("elinux/faktury/margRightPrinter").toInt()*4);
    pageMargDown=static_cast<double>(settings.readEntry ("elinux/faktury/margDownPrinter").toInt()*4);        
  view=new QScrollView(frame4,"view");
  view->setGeometry(0,0,frame4->width(),frame4->height());
  label=new QLabel("",NULL);
  view->addChild(label,0,0);
  label->setGeometry(0,0,840,1188);

}



void PrintPreview::setTableTemp( TableTemp & t,QString progdir2,QString retrn )
{
 //qDebug("setTableTemp");
 tabletemp=t;
 makePixmap();
 this->setCaption(tabletemp.data.Title);
 progDir2=progdir2;
 ret=retrn;
 if(tabletemp.data.paidCash==false)
     pushButton6->setEnabled(true);
  label->setPixmap(pixmap[0]); 
}


void PrintPreview::makePixmap()
{
 //   qDebug("makePixmap");
    setVisibleColumn();
    if(makePdf)
    {
                if(pixmap_pdf.size()==0)
	{
	pixmap_pdf.push_back(QPixmap(840*scale,1188*scale));
	pixmap_pdf[0].fill();	
	QPainter p(&pixmap_pdf[0]);    
	drawHeader(p);    
	p.end();
	drawBody();
	drawPageSummary();
                }
    }
    else
    {
	pixmap.push_back(QPixmap(840,1188));
	pixmap[0].fill();	
	QPainter p(&pixmap[0]);    
	drawHeader(p);    
	p.end();
	drawBody();
	drawPageSummary();
	pagespinbox->setMaxValue(pixmap.size());     	
    }
}

    

void PrintPreview::exportPdf()
{
  //  qDebug("exportPdf");
    int temp_i=0;
    bool ok=false,eXit=false;
    QString filename;
    while(!ok)
    {
    while(filename=="")
	{
	filename=QFileDialog::getSaveFileName(QString::null,"*.pdf");
	if(filename=="")
	{
	    temp_i=QMessageBox::question(this, "QFaktury", tr("Czy chcesz anulowa? "),QMessageBox::Yes ,QMessageBox::No );
	if(temp_i==QMessageBox::Yes)
	   {
	    eXit=true;
	    break;
	}
                }
               }
    QFileInfo filenameinfo(filename);
    if((filenameinfo.extension()).upper()!="PDF")
        filename+=".pdf";    
    if(QFile::exists(filename))
    {	
	temp_i=QMessageBox::question(this, "QFaktury", tr("Czy chcesz nadpisa plik? "),QMessageBox::Yes ,QMessageBox::No );
	if(temp_i==QMessageBox::Yes)
	  {
	  QFile::remove(filename);
	  ok=true;
                  }
    }
    else
    {
	ok=true;
    }
}
  if(eXit==false)
    {
      this->setCaption(tr("Trwa eksportowanie..."));
//    this->setEnabled(false);          
      makePdf=true;
      QSettings settings;
      scale=settings.readEntry ("elinux/faktury/pdfQuality").toInt()+1;
     makePixmap();
    QStringList args;
    args+="convert";
    args+=" -size +1050+1485 ";
    for(unsigned int i=0;i<pixmap_pdf.size();++i)
    {
      args+="/tmp/image"+QString::number(i)+".png";
      pixmap_pdf[i].save("/tmp/image"+QString::number(i)+".png","PNG");    
    }
    args+=filename;
    cmd3=new QProcess (args);
    connect(cmd3,SIGNAL(processExited()),this,SLOT(pdfFinished()));

    if(!cmd3->start())
       {
        QMessageBox::information (this, "QFaktury", tr("Zainstaluj pakiet Image Magick!!!"),QMessageBox::Ok);
//        this->setEnabled(true);	
       }
    }
}


void PrintPreview::pdfFinished()
{
  //    qDebug("pdfFinished");
      for(unsigned int i=0;i<pixmap.size();++i)
      {
        QFile::remove("/tmp/image"+QString::number(i)+".png");
      }
      delete cmd3;
      pixmap_pdf.clear();
      QMessageBox::information (this, "QFaktury", tr("Faktura zostaa wyeksportowana do pliku *.pdf"),QMessageBox::Ok);    
      this->setCaption(tabletemp.data.Title);      
}


void PrintPreview::drawHeader( QPainter &p )
{
    QSettings settings;
    QString qstringTemp = settings.readEntry ("elinux/faktury/logo");
    if (qstringTemp != "")
    {
    QPainter p1;
    if(makePdf)
      p1.begin(&pixmap_pdf[0]);
    else
      p1.begin(&pixmap[0]);
    QPixmap qpixm(qstringTemp);
    p1.setWindow(0,0,qpixm.width(),qpixm.height());
    p1.setViewport((10+margLeft)*scale,(10+margTop)*scale,200*scale,100*scale);
    p1.drawPixmap(0,0,qpixm);
    }
    else
    {
	p.drawText((10+margLeft)*scale,(10+margTop)*scale,tr("Piecz wystawcy"));	
    }
    p.setFont(QFont("Times",22*scale));
    p.drawText((300+margLeft)*scale,(50+margTop)*scale,tabletemp.data.Title);
    p.setFont(QFont("Times",18*scale));
    p.drawText((300+margLeft)*scale,(80+margTop)*scale,tabletemp.data.Number);
    p.setFont(QFont("Times",12*scale));
    p.drawText((300+margLeft)*scale,(100+margTop)*scale,tabletemp.data.sellingDate);
    p.drawText((300+margLeft)*scale,(120+margTop)*scale,tabletemp.data.creatingDate);
    p.setFont(QFont("Times",22*scale));
    p.drawText((330+margLeft)*scale,(160+margTop)*scale,tr("ORYGINA/KOPIA"));
    p.setFont(QFont("Times",18*scale));
    p.drawLine((margLeft)*scale,(200+margTop)*scale,(pixmap[0].width()-margRight)*scale,(200+margTop)*scale);

    p.drawText((10+margLeft)*scale,(250+margTop)*scale,tr("Sprzedawca:"));
    p.drawText((430+margLeft)*scale,(250+margTop)*scale,tr("Nabywca:"));
    p.setFont(QFont("Times",10*scale));
    
    int temp_i=0,temp_i1=0,temp_i2=0;    
	
    if(settings.readBoolEntry("elinux/printpos/usernazwa") && settings.readEntry("elinux/user/nazwa").remove(" ")!="")
    {
	p.drawText((20+margLeft)*scale,(270+margTop+temp_i)*scale,settings.readEntry ("elinux/user/nazwa"));
	temp_i+=20;
	++temp_i1;
    }
        if(settings.readBoolEntry("elinux/printpos/usermiejscowosc") && settings.readEntry("elinux/user/miejscowosc").remove(" ")!="")
    {
	    p.drawText((20+margLeft)*scale,(270+margTop+temp_i)*scale,settings.readEntry ("elinux/user/kod")+" "+settings.readEntry ("elinux/user/miejscowosc"));
	temp_i+=20;
	++temp_i1;
    }
        if(settings.readBoolEntry("elinux/printpos/useradres") && settings.readEntry("elinux/user/adres").remove(" ")!="")
    {
	    p.drawText((20+margLeft)*scale,(270+margTop+temp_i)*scale,settings.readEntry ("elinux/user/adres"));
	    temp_i+=20;
	    ++temp_i1;
    }
	if(settings.readBoolEntry("elinux/printpos/usernip") && settings.readEntry("elinux/user/nip").remove(" ").remove("-")!="")
    {
	    p.drawText((20+margLeft)*scale,(270+margTop+temp_i)*scale,tr("NIP: ") +settings.readEntry ("elinux/user/nip"));
	    temp_i+=20;
  	    ++temp_i1;
    }	
        if(settings.readBoolEntry("elinux/printpos/userkonto") && settings.readEntry("elinux/user/konto").remove(" ").remove("-")!="")
    {
	    p.drawText((20+margLeft)*scale,(270+margTop+temp_i)*scale,tr("Nr konta: ") +settings.readEntry ("elinux/user/konto"));
	    temp_i+=20;
  	    ++temp_i1;
    }	
        if(settings.readBoolEntry("elinux/printpos/userphone") && settings.readEntry("elinux/user/phone").remove(" ")!="")
    {
	    p.drawText((20+margLeft)*scale,(270+margTop+temp_i)*scale,tr ("Telefon: ") + settings.readEntry ("elinux/user/phone"));
	    temp_i+=20;
	    ++temp_i1;
    }
        if(settings.readBoolEntry("elinux/printpos/usermail") && settings.readEntry("elinux/user/email").remove(" ")!="")
    {
	    p.drawText((20+margLeft)*scale,(270+margTop+temp_i)*scale,tr ("E-mail: ") + settings.readEntry ("elinux/user/email"));
	    temp_i+=20;
	    ++temp_i1;
    }
        if(settings.readBoolEntry("elinux/printpos/userwww") && settings.readEntry("elinux/user/www").remove(" ")!="")
    {
	    p.drawText((20+margLeft)*scale,(270+margTop+temp_i)*scale,tr ("WWW: ") + settings.readEntry ("elinux/user/www"));    
	    temp_i+=20;
	    ++temp_i1;
    }
temp_i=0;
    settings.beginGroup ("elinux/printpos");
    QStringList qstringlist=QStringList::split(",",tabletemp.data.client);

    if(qstringlist.size()==8)
    {
	QString temporary="  "+qstringlist[0];
	if( settings.readBoolEntry("clientnazwa") && qstringlist[0].remove(" ")!="")
	{
	    p.drawText((440+margLeft)*scale,(270+temp_i+margTop)*scale,temporary);
	    temp_i+=20;
	    ++temp_i2;
	}
	temporary=qstringlist[1];
	if( settings.readBoolEntry("clientmiejscowosc") && qstringlist[1].remove(" ")!="")
	{
	    p.drawText((440+margLeft)*scale,(270+temp_i+margTop)*scale,temporary);
	    temp_i+=20;
	    ++temp_i2;
	}
	temporary=qstringlist[2];
	if(settings.readBoolEntry("clientadres") && qstringlist[2].remove(" ")!="")
	{
	    p.drawText((440+margLeft)*scale,(270+temp_i+margTop)*scale,temporary);
	    temp_i+=20;
	    ++temp_i2;
	}
	temporary=qstringlist[3];
	if(settings.readBoolEntry("clientnip") &&  qstringlist[3].remove(" ").remove("-")!="")
	{
	    p.drawText((440+margLeft)*scale,(270+temp_i+margTop)*scale,tr("  NIP: ") +temporary);
	    temp_i+=20;
	    ++temp_i2;
	}
	temporary=qstringlist[4];
	if( settings.readBoolEntry("clientkonto") && qstringlist[4].remove(" ").remove("-")!="")
	{
	    p.drawText((440+margLeft)*scale,(270+temp_i+margTop)*scale,tr("  Nr konta: ")+temporary);
	    temp_i+=20;
	    ++temp_i2;
	}
	temporary=qstringlist[5];
	if( settings.readBoolEntry("clientphone") && qstringlist[5].remove(" ")!="")
	{
	    p.drawText((440+margLeft)*scale,(270+temp_i+margTop)*scale,tr ("  Telefon: ") +temporary);
	    temp_i+=20;
	    ++temp_i2;
	}
	temporary=qstringlist[6];
	if( settings.readBoolEntry("clientmail") && qstringlist[6].remove(" ")!="")
	{
	    p.drawText((440+margLeft)*scale,(270+temp_i+margTop)*scale,tr ("  E-mail: ") + temporary);
	    temp_i+=20;
	    ++temp_i2;
	}
	temporary=qstringlist[7];
	if( settings.readBoolEntry("clientwww") && qstringlist[7].remove(" ")!="")
	{
	    p.drawText((440+margLeft)*scale,(270+temp_i+margTop)*scale,tr ("  WWW: ") + temporary);
	    temp_i+=20;
	    ++temp_i2;
	}
     }
    else
    {
//	qDebug("Za ilo danych!!!: "+QString::number(qstringlist.size()));
//	qDebug(tabletemp.data.client);
//	for (QStringList::Iterator it = qstringlist.begin() ; it != qstringlist.end(); ++it)
//	    qDebug(*it);
    }
	settings.endGroup ();     
	countPos= ( temp_i1>temp_i2 ? temp_i1 : temp_i2);
    p.drawLine(margLeft*scale,(290+countPos*20+margTop)*scale,(pixmap[0].width()-margRight)*scale,(290+countPos*20+margTop)*scale);	
    }



void PrintPreview::drawPageSummary()
{
    QPainter p;
    for(unsigned int i=0;i<pixmap.size();++i)
    {
    if(makePdf)
	p.begin(&pixmap_pdf[i]);
    else
	p.begin(&pixmap[i]);
    p.drawLine((margLeft)*scale,(pixmap[0].height()-20-margDown)*scale,(pixmap[0].width()-margRight)*scale,(pixmap[0].height()-20-margDown)*scale);
    p.setFont(QFont("Times",8*scale));
    QString s(tr("QFaktury GPL wersja "));  
    s+=version;
    p.drawText((margLeft+10)*scale,(pixmap[0].height()-margDown-10)*scale,s);
    p.drawText((pixmap[0].width()-margRight-200)*scale,(pixmap[0].height()-margDown-10)*scale,tr("e-linux.pl"));
    p.drawText((pixmap[0].width()/2-40)*scale,(pixmap[0].height()-margDown-10)*scale,tr("strona ")+QString::number(i+1)+"/"+QString::number(pixmap.size()));
   p.end();
   }
}


void PrintPreview::exportHtml()
{
  //eksport do html
    QStringList fraStrList;
  QSettings settings;
  QString localEnc = settings.readEntry ("elinux/localEnc", "ISO-8859-2");
    QDir abs (qApp->argv ()[0]);
    QString templDir;
  if (QString (qApp->argv ()[0]).left (2) == "./")
    templDir = abs.absPath ();
  else
    templDir = "/usr/bin/qfaktury";
//  this->setCaption(templDir);
    templDir = templDir.replace ("bin", "share");
  templDir = templDir + "/templates/";
//    this->setCaption(templDir);
  fraStrList += "<html><head>";
  fraStrList += tr("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=" + localEnc + "\" />");
  fraStrList += "<meta name=\"creator\" value=\"http://www.e-linux.pl\" />";
  fraStrList += "</head>";
  
  fraStrList +="<title>"+tabletemp.data.Title+"</title>";
  fraStrList += "<style type=\"text/css\"><!-- ";
    QFile file (templDir + "style.css");
  if (file.open (IO_ReadOnly))
    {
      QTextStream stream (&file);
      QString line;
      while (!stream.atEnd ())
	{
	  line = stream.readLine ();
	  fraStrList += line;
	}
      file.close ();
    }
  
  fraStrList += "--></style>";
  fraStrList += "<body>";
  fraStrList += "<table width=\"700\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">";
   fraStrList += "<tr comment=\"headar\"><td>";
  fraStrList +=
    "<table comment=\"headar table\" width=\"100%\" border=\"0\">";
  fraStrList += "<tr>";
  fraStrList +=
    "<td colspan=\"2\" width=\"60%\" align=\"left\" valign=\"center\" class=\"podpisy\">"; 
    QString logo = settings.readEntry ("elinux/faktury/logo");
  if (logo != "")
    {
      fraStrList +=
	"<img src=\"" + logo + "\"  width=\"200\" height=\"100\">";
    }
  else
    {
      fraStrList += tr("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Piecz wystawcy");
    }
  fraStrList += "</td>";
  fraStrList += "<td>";
  fraStrList += tr("<h2>"+tabletemp.data.Title+"<br>");
  fraStrList += tabletemp.data.Number + "<br></h2>";
  fraStrList += "<h5>" + tabletemp.data.creatingDate+"<br>";
  fraStrList += tabletemp.data.sellingDate+"<br></h5>";
  fraStrList += "</td>";
  fraStrList += "<td width=\"20\">&nbsp;</td>";
  fraStrList += "</tr>";
  fraStrList += "<tr>";
  fraStrList += "<td colspan=\"3\" align=\"right\" valign=\"top\">";
  fraStrList += "<br>" + tr("ORYGINA/KOPIA") + "<br>";
  fraStrList += "</td>";
  fraStrList += "<td width=\"20\">&nbsp;</td>";
  fraStrList += "</tr>";
  fraStrList += "</table>";
  fraStrList += "</td></tr>";
  
    fraStrList += "<tr comment=\"body\"><td>";
  fraStrList += "<table width=\"100%\" border=\"0\">";
  fraStrList += "<tr>";
  fraStrList += "<td witdh=\"20\">&nbsp;</td>";
  fraStrList += "<td width=\"48%\" valign=\"top\">";
  fraStrList += tr("<h4>Sprzedawca:</h4>");
    
      if(settings.readBoolEntry("elinux/printpos/usernazwa") && settings.readEntry("elinux/user/nazwa").remove(" ")!="")
    {
	 fraStrList += "<h5>" + settings.readEntry ("elinux/user/nazwa") + "<br>";
    }
        if(settings.readBoolEntry("elinux/printpos/usermiejscowosc") && settings.readEntry("elinux/user/miejscowosc").remove(" ")!="")
    {
	    fraStrList +=settings.readEntry ("elinux/user/kod") + " " + settings.readEntry ("elinux/user/miejscowosc") + "<br>";
    }
        if(settings.readBoolEntry("elinux/printpos/useradres") && settings.readEntry("elinux/user/adres").remove(" ")!="")
    {
	    fraStrList += settings.readEntry ("elinux/user/adres") + "<br>";
    }
	if(settings.readBoolEntry("elinux/printpos/usernip") && settings.readEntry("elinux/user/nip").remove(" ").remove("-")!="")
    {
	    fraStrList += tr("  NIP: ") + settings.readEntry ("elinux/user/nip") + "<br>";
    }	
        if(settings.readBoolEntry("elinux/printpos/userkonto") && settings.readEntry("elinux/user/konto").remove(" ").remove("-")!="")
    {
	    fraStrList +=tr("  Konto: ") + settings.readEntry ("elinux/user/konto").replace ("-"," ") +"<br>";
    }	
        if(settings.readBoolEntry("elinux/printpos/userphone") && settings.readEntry("elinux/user/phone").remove(" ")!="")
    {
	    fraStrList +=tr ("  Telefon: ") + settings.readEntry ("elinux/user/phone") + "<br>";
    }
        if(settings.readBoolEntry("elinux/printpos/usermail") && settings.readEntry("elinux/user/email").remove(" ")!="")
    {
	    fraStrList +=tr ("E-mail: ") + settings.readEntry ("elinux/user/email") + "<br>";
    }
        if(settings.readBoolEntry("elinux/printpos/userwww") && settings.readEntry("elinux/user/www").remove(" ")!="")
    {
	    fraStrList +=tr ("  www: ") + settings.readEntry ("elinux/user/www") + "<br>";
    }
    settings.beginGroup ("elinux/printpos");
    
      fraStrList += "</h5>";
  fraStrList += "</td>";
  fraStrList += "<td witdh=\"20\">&nbsp;</td>";
  fraStrList += "<td width=\"48%\" valign=\"top\">";
  fraStrList += tr("<h4>Nabywca:</h4>");
  fraStrList += "<h5>";
    QStringList qstringlist=QStringList::split(",",tabletemp.data.client);

    if(qstringlist.size()==8)
    {
	QString temporary="  "+qstringlist[0];
	if( settings.readBoolEntry("clientnazwa") && qstringlist[0].remove(" ")!="")
	{
	    fraStrList+=temporary+"<br>";
	}
	temporary=qstringlist[1];
	if( settings.readBoolEntry("clientmiejscowosc") && qstringlist[1].remove(" ")!="")
	{
	    fraStrList+=temporary+"<br>";
	}
	temporary=qstringlist[2];
	if(settings.readBoolEntry("clientadres") && qstringlist[2].remove(" ")!="")
	{
	    fraStrList+=temporary+"<br>";
	}
	temporary=qstringlist[3];
	if(settings.readBoolEntry("clientnip") &&  qstringlist[3].remove(" ").remove("-")!="")
	{
	    fraStrList+=tr("  NIP: ") +temporary+"<br>";
	}
	temporary=qstringlist[4];
	if( settings.readBoolEntry("clientkonto") && qstringlist[4].remove(" ").remove("-")!="")
	{
	      fraStrList+=tr("  Nr konta: ")+temporary+"<br>";
	}
	temporary=qstringlist[5];
	if( settings.readBoolEntry("clientphone") && qstringlist[5].remove(" ")!="")
	{
	      fraStrList+=tr ("  Telefon: ") +temporary+"<br>";
	}
	temporary=qstringlist[6];
	if( settings.readBoolEntry("clientmail") && qstringlist[6].remove(" ")!="")
	{
	      fraStrList+=tr ("  E-mail: ") + temporary+"<br>";
	}
	temporary=qstringlist[7];
	if( settings.readBoolEntry("clientwww") && qstringlist[7].remove(" ")!="")
	{
	      fraStrList+=tr ("  www: ") + temporary+"<br>";
	}
     }
    else
    {
//	qDebug("Za ilo danych!!!: "+QString::number(qstringlist.size()));
//	qDebug(tabletemp.data.client);
//	for (QStringList::Iterator it = qstringlist.begin() ; it != qstringlist.end(); ++it)
//	    qDebug(*it);
    }
	settings.endGroup ();     
  fraStrList += "</h5>";
  fraStrList += "</td>";
  fraStrList += "</tr>";
  fraStrList += "</table>";
  fraStrList += "</td></tr>";
  
  fraStrList += "<tr comment=\"goods\" align=\"center\"><td>";
  fraStrList += "<br><br>";
  fraStrList += "<table width=\"100%\" border=\"1\" class=\"goods\">";
  fraStrList += "<tr class=\"towaryN\">";

  
  if (visibleColumns[0])
    fraStrList += tr("<td width=\"20\"  align=\"center\"> " + tr("Lp.") + "</td>");
  if (visibleColumns[1])
    fraStrList += tr("<td width=\"120\" align=\"center\"> " + tr("Nazwa") + "</td>");
  if (visibleColumns[2])
    fraStrList += tr("<td width=\"60\" align=\"center\"> " + tr("Kod") + "</td>");
  if (visibleColumns[3])
    fraStrList += tr("<td width=\"60\" align=\"center\"> " + tr("PKWiU") + "</td>");
  if (visibleColumns[4])
     fraStrList += tr("<td width=\"60\" align=\"center\"> " + tr("Ilo") + "</td>");
  if (visibleColumns[5])
     fraStrList += tr("<td width=\"20\" align=\"center\"> " + tr("Jm.") + "</td>");
  if (visibleColumns[6])
    fraStrList += tr("<td width=\"60\" align=\"center\"> " + tr("Cena jdn.") + "</td>");
  if (visibleColumns[7])
     fraStrList += tr("<td width=\"60\" align=\"center\"> " + tr("Warto Netto") + "</td>");
  if (visibleColumns[8])
     fraStrList += tr("<td width=\"20\" align=\"center\"> " + tr("Rabat %") + "</td>");
  if (visibleColumns[9])
     fraStrList += tr("<td width=\"20\" align=\"center\"> " + tr("Rabat Warto") + "</td>"); 
  if (visibleColumns[10])
     fraStrList += tr("<td width=\"60\" align=\"center\"> " + tr("Netto po rabacie") + "</td>");      
  if (visibleColumns[11])
     fraStrList += tr("<td width=\"60\" align=\"center\"> " + tr("Stawka VAT") + "</td>");
  if (visibleColumns[12])
     fraStrList += tr("<td width=\"60\" align=\"center\"> " + tr("Kwota Vat") + "</td>"); 
  if (visibleColumns[13])
     fraStrList += tr("<td width=\"60\" align=\"center\"> " + tr("Warto Brutto") + "</td>");    fraStrList += "</tr>";

   for (unsigned int i = 0; i < tabletemp.vec_temp.size(); ++i)
    {
       fraStrList += "<tr class=\"towaryList\">";
       if (visibleColumns[0])
	   fraStrList += "<td>&nbsp;" + tabletemp.vec_temp[i][0] + "</td>";
       if (visibleColumns[1])
	   fraStrList += "<td>&nbsp;" + tabletemp.vec_temp[i][1] + "</td>";
       if (visibleColumns[2])
	   fraStrList += "<td>&nbsp;" + tabletemp.vec_temp[i][2] + "</td>";
       if (visibleColumns[3])
	   fraStrList += "<td>&nbsp;" +tabletemp.vec_temp[i][3]+ "</td>";
       if (visibleColumns[4])
	   fraStrList += "<td>&nbsp;" + tabletemp.vec_temp[i][4] + "</td>";
       if (visibleColumns[5])
	   fraStrList += "<td>&nbsp;" + tabletemp.vec_temp[i][5] + "</td>";
       if (visibleColumns[6])
	   fraStrList += "<td>&nbsp;" + tabletemp.vec_temp[i][6] + "</td>";
       if (visibleColumns[7])
	   fraStrList += "<td>&nbsp;" + tabletemp.vec_temp[i][7] + "</td>";	// netto przed rab
       if (visibleColumns[8])
	   fraStrList += "<td>&nbsp;" + tabletemp.vec_temp[i][8] + "% </td>";	// rabat
       if (visibleColumns[9])
	   fraStrList += "<td>&nbsp;" + tabletemp.vec_temp[i][9] + " </td>";             
       if (visibleColumns[10])
	   fraStrList += "<td>&nbsp;" + tabletemp.vec_temp[i][10] + "</td>";	// netto po rab
       if (visibleColumns[11])
	   fraStrList += "<td>&nbsp;" + tabletemp.vec_temp[i][11] + "%</td>";
       if (visibleColumns[12])
	  fraStrList +="<td>&nbsp;" +tabletemp.vec_temp[i][12]  + "</td>";
      if (visibleColumns[13])
	  fraStrList += "<td>&nbsp;" + tabletemp.vec_temp[i][13] + "</td>";
      fraStrList += "</tr>";
  }

  fraStrList += "</table>";
  fraStrList += "</td></tr>";

 
  fraStrList += "<tr comment=\"razem\" align=\"center\"><td>";
  fraStrList += "<table width=\"100%\" border=\"0\">";
  fraStrList += "<tr class=\"stawki\">";
  
  if (visibleColumns[0])
    fraStrList += "<td width=\"20\"  align=\"center\">&nbsp;</td>";
  if (visibleColumns[1])
    fraStrList += "<td width=\"120\" align=\"center\">&nbsp;</td>";
  if (visibleColumns[2])
    fraStrList += "<td width=\"60\" align=\"center\">&nbsp;</td>";
  if (visibleColumns[3])
    fraStrList += "<td width=\"60\" align=\"center\">&nbsp;</td>";
  if (visibleColumns[4])
    fraStrList += "<td width=\"60\" align=\"center\">&nbsp;</td>";
  if (visibleColumns[5])
    fraStrList += "<td width=\"20\" align=\"center\">&nbsp;</td>";
  if (visibleColumns[6])
    fraStrList += "<td width=\"60\" align=\"center\">&nbsp;</td>";
  if (visibleColumns[7])
    fraStrList += "<td width=\"60\" align=\"center\">&nbsp;</td>";
  if (visibleColumns[8])
    fraStrList += "<td width=\"20\" align=\"center\">&nbsp;</td>";
  if (visibleColumns[9])
    fraStrList += "<td width=\"20\" align=\"center\">&nbsp;</td>";
  
  
  fraStrList += tr("<td width=\"140\">&nbsp;Razem:</td>");
  fraStrList += "<td width=\"60\">&nbsp;" + tabletemp.data.netto + "</td>";	// netto
  if (visibleColumns[11])
    fraStrList += "<td width=\"60\">&nbsp;</td>";
  if (visibleColumns[12])
    fraStrList += "<td width=\"60\">&nbsp;" +tabletemp.data.vat + "</td>";	// vat
  fraStrList += "<td width=\"60\">&nbsp;" + tabletemp.data.brutto + "</td>";	// brutto

  fraStrList += "</tr>";
  fraStrList += "</table>";
  fraStrList += "</td></tr>";
  
    fraStrList += tr("<tr comment=\"podsumowanie\"><td>");
  fraStrList += "<table width=\"100%\" border=\"0\">";
  fraStrList += "<tr>";
  fraStrList += "<td witdh=\"20\">&nbsp;</td>";
  fraStrList += "<td width=\"48%\"> ";
  fraStrList += "<h4>" + tr("Do zapaty: ") + tabletemp.data.sum + "</h4>";
  fraStrList +="<h5>" + tr("sownie: ") + tabletemp.data.sumStr+ "</h5>";
  fraStrList += "<h5>" + tr( "forma patnoci: " ) + tabletemp.data.payMode + "<br>";
  fraStrList += tr("termin patnoci: ") + tabletemp.data.payDate + "<br>";
  QString paym1 = settings.readEntry ("elinux/faktury/paym1");
  if(tabletemp.data.paidCash)
    fraStrList += tr("<b>Zapacono gotwk</b> <br>");
  else
    fraStrList += tr("<b>Zapata przelewem</b> <br>");
  fraStrList += "</h5>";
  fraStrList += "<h4>" + tabletemp.data.additText+ "</h4>";
  fraStrList += "</td>";
  fraStrList += "<td witdh=\"20\">&nbsp;</td>";
  fraStrList += "<td width=\"48%\" valign=\"top\">";
  fraStrList += "<table width=\"90%\" class=\"stawki\" border=\"0\">";
  
  fraStrList += "<tr>";
  fraStrList +=
    "<td colspan=\"4\"><hr width=\"100%\" noshade=\"noshade\" color=\"black\" /></td>";
  fraStrList += "</tr>";
  fraStrList += "<tr>";
  fraStrList += "<td colspan=\"4\"><h5>" + tr("Ogem stawkami:") + "</h5>";
  fraStrList += "</td>";	// Ogem stawkami:
  fraStrList += "</tr>";
  
  
      QStringList bidsList=QStringList::split(";",tabletemp.data.Bids);
      QStringList::Iterator it = bidsList.begin();
  
  
  for(int i=0;i<4;++i)
  {
      fraStrList+="<tr>";
      for(int j=0;j<4;++j)
      {
      fraStrList+="<td>"+*it+"</td>";
      ++it;
      }
      fraStrList+="</tr>";
  }
  fraStrList += "<tr>";
  fraStrList += "<td>&nbsp;</td>";	// netto
  fraStrList += "<td>&nbsp;</td>";	// stawka
  fraStrList += "<td>&nbsp;</td>";	// podatek
  fraStrList += "<td>&nbsp;</td>";	// brutto
  fraStrList += "</tr>";
  fraStrList += "</table>";
  fraStrList += "</td>";
  fraStrList += "</tr>";
  fraStrList += "</table>";
  fraStrList += "</td></tr>";
  
  
  fraStrList += "<tr comment=\"podpis\" align=\"center\"><td>";
  fraStrList += "<br><br><br><br>";
  fraStrList += "<table width=\"80%\" border=\"0\">";
  fraStrList += "<tr>";
  fraStrList += "<td witdh=\"20\">&nbsp;</td>";
  fraStrList += "<td witdh=\"48%\" align=\"center\"> ";
  fraStrList += "<hr width=\"100%\" noshade=\"noshade\" color=\"black\" />";
  fraStrList += "</td>";
  fraStrList += "<td witdh=\"60\">&nbsp;</td>";
  fraStrList += "<td witdh=\"20\">&nbsp;</td>";
  fraStrList += "<td witdh=\"48%\" align=\"center\"> ";
  fraStrList += "<hr width=\"100%\" noshade=\"noshade\" color=\"black\" />";
  fraStrList += "</td>";
  fraStrList += "</tr>";
  fraStrList += "<tr class=\"podpisy\">";
  fraStrList += "<td witdh=\"20\">&nbsp;</td>";
  fraStrList += "<td witdh=\"48%\" align=\"center\"> ";
  
#ifdef QF_base__
  fraStrList += tr("Imi i nazwisko osoby upowanionej do wystawienia faktury VAT");
#endif

#ifdef QF_vatmp__
  fraStrList += tr("Imi i nazwisko osoby upowanionej do wystawienia faktury VAT");
#endif

#ifdef QF_noVAT__
  fraStrList += tr("Imi i nazwisko osoby upowanionej do wystawienia rachunku");
#endif      
  
  fraStrList += "</td>";
  fraStrList += "<td witdh=\"60\">&nbsp;</td>";
  fraStrList += "<td witdh=\"20\">&nbsp;</td>";
  fraStrList += "<td witdh=\"48%\" align=\"center\"> ";

#ifdef QF_base__
  fraStrList += tr("Imi i nazwisko osoby upowanionej do odbioru faktury VAT");
#endif

#ifdef QF_vatmp__
  fraStrList += tr("Imi i nazwisko osoby upowanionej do odbioru faktury VAT");
#endif

#ifdef QF_noVAT__
  fraStrList += tr("Imi i nazwisko osoby upowanionej do odbioru rachunku");
#endif      

  fraStrList += "</td>";
  fraStrList += "</tr>";
  fraStrList += "</table>";
  fraStrList += "</td></tr>";
  fraStrList += "</table>";
  fraStrList += "<tr comment=\"comment\" align=\"left\"><td>";
  fraStrList += "</td></tr>";
  fraStrList += "</table>";
  fraStrList += "<h6>" + tr("QFaktury e-linux.pl wersja ")+version;
  fraStrList += "<h6>";
  fraStrList += "</body>";
  fraStrList += "</html>";  
  
  
      QFile file1 ("/tmp/invoice.html");
  if (file1.open (IO_WriteOnly))
    {
      QTextStream stream (&file1);
      for (QStringList::Iterator it = fraStrList.begin ();
	   it != fraStrList.end (); ++it)
	stream << *it << "\n";
      file1.close ();
    }

  QStringList args;
  if (settings.readBoolEntry ("elinux/default_browser", TRUE))
    {
      // firts we check is KDE working
      args += "kfmclient";
      args += "exec";
      args += "/tmp/invoice.html";
      QProcess cmd (args);
      if (!cmd.start ())
	{
	  // if not we use GNOME2 api
	  args.clear ();
	  args += "gnome-open";
	  args += "/tmp/invoice.html";
	  QProcess cmd2 (args);
	  cmd2.start ();
	}
    }
  else
    {
      args += settings.readEntry ("elinux/browser_name", "mozilla");
      args += "/tmp/invoice.html";
      QProcess cmd3 (args);
      cmd3.start ();
    }
}

#include <qprinter.h>
void PrintPreview::printPages()
{
    QPrinter printer;
    printer.setFullPage( TRUE );
    printer.setDocName("QFaktury GPL");
    QSettings settings;
    if(printer.setup(this))
    {
     QPainter p(&printer);
     QRect rect=p.viewport();
     xrate=static_cast<float>(rect.width())/840.0;
     yrate=static_cast<float>(rect.height())/1188.0;
    QString qstringTemp = settings.readEntry ("elinux/faktury/logo");
    if (qstringTemp != "")
    {
    QPixmap pix2(static_cast<int>(200.0*xrate),static_cast<int>(100.0*yrate));
    QPainter p1;
    p1.begin(&pix2);
    QPixmap qpixm(qstringTemp);
    p1.setWindow(0,0,qpixm.width(),qpixm.height());
    p1.setViewport(0,0,static_cast<int>(200.0*xrate),static_cast<int>(100.0*yrate));
    p1.drawPixmap(0,0,qpixm);
    p1.end();
    p.drawPixmap(static_cast<int>((10.0+pageMargLeft)*xrate),static_cast<int>((5.0+pageMargTop)*yrate),pix2);	
    }
    else
    {
	p.drawText(static_cast<int>((10.0+pageMargLeft)*xrate),static_cast<int>((10.0+pageMargTop)*yrate),tr("Piecz wystawcy"));	
    }
    
    p.setFont(QFont("Times",static_cast<int>(22.0*yrate)));
    p.drawText(static_cast<int>((300.0+pageMargLeft)*xrate),static_cast<int>((50.0+pageMargTop)*yrate),tabletemp.data.Title);
    p.setFont(QFont("Times",static_cast<int>(18.0*yrate)));
    p.drawText(static_cast<int>((300.0+pageMargLeft)*xrate),static_cast<int>((80.0+pageMargTop)*yrate),tabletemp.data.Number);
    p.setFont(QFont("Times",static_cast<int>(12.0*yrate)));
    p.drawText(static_cast<int>((300.0+pageMargLeft)*xrate),static_cast<int>((100.0+pageMargTop)*yrate),tabletemp.data.sellingDate);
    p.drawText(static_cast<int>((300.0+pageMargLeft)*xrate),static_cast<int>((120.0+pageMargTop)*yrate),tabletemp.data.creatingDate);
    p.setFont(QFont("Times",static_cast<int>(22*yrate)));
    p.drawText(static_cast<int>((330.0+pageMargLeft)*xrate),static_cast<int>((160+pageMargTop)*yrate),tr("ORYGINA/KOPIA"));
    p.setFont(QFont("Times",static_cast<int>(18*yrate)));
    p.drawLine(static_cast<int>((pageMargLeft)*xrate),static_cast<int>((200.0+pageMargTop)*yrate),rect.width()-static_cast<int>(pageMargRight*xrate),static_cast<int>((200.0+pageMargTop)*yrate));
    
    p.drawText(static_cast<int>((10.0+pageMargLeft)*xrate),static_cast<int>((250.0+pageMargTop)*yrate),tr("Sprzedawca:"));
    p.drawText(static_cast<int>((430.0+pageMargLeft)*xrate),static_cast<int>((250.0+pageMargTop)*yrate),tr("Nabywca:"));
    p.setFont(QFont("Times",static_cast<int>(10.0*yrate)));
    
    float temp_f=0.0;
    int temp_i1=0,temp_i2=0;    
   
    if(settings.readBoolEntry("elinux/printpos/usernazwa") && settings.readEntry("elinux/user/nazwa").remove(" ")!="")
    {
	p.drawText(static_cast<int>((20.0+pageMargLeft)*xrate),static_cast<int>((270.0+pageMargTop+temp_f)*yrate),settings.readEntry ("elinux/user/nazwa"));
	temp_f+=20.0;
	++temp_i1;
    }
        if(settings.readBoolEntry("elinux/printpos/usermiejscowosc") && settings.readEntry("elinux/user/miejscowosc").remove(" ")!="")
    {
	    p.drawText(static_cast<int>((20.0+pageMargLeft)*xrate),static_cast<int>((270.0+pageMargTop+temp_f)*yrate),settings.readEntry ("elinux/user/miejscowosc"));
	temp_f+=20.0;
	++temp_i1;
    }
        if(settings.readBoolEntry("elinux/printpos/useradres") && settings.readEntry("elinux/user/adres").remove(" ")!="")
    {
	     p.drawText(static_cast<int>((20.0+pageMargLeft)*xrate),static_cast<int>((270.0+pageMargTop+temp_f)*yrate),settings.readEntry ("elinux/user/adres"));
	    temp_f+=20.0;
	    ++temp_i1;
    }
	if(settings.readBoolEntry("elinux/printpos/usernip") && settings.readEntry("elinux/user/nip").remove(" ").remove("-")!="")
    {
	     p.drawText(static_cast<int>((20.0+pageMargLeft)*xrate),static_cast<int>((270.0+pageMargTop+temp_f)*yrate),settings.readEntry ("elinux/user/nip"));
	    temp_f+=20.0;
  	    ++temp_i1;
    }	
        if(settings.readBoolEntry("elinux/printpos/userkonto") && settings.readEntry("elinux/user/konto").remove(" ").remove("-")!="")
    {
	     p.drawText(static_cast<int>((20.0+pageMargLeft)*xrate),static_cast<int>((270.0+pageMargTop+temp_f)*yrate),settings.readEntry ("elinux/user/konto"));
	    temp_f+=20.0;
  	    ++temp_i1;
    }	
        if(settings.readBoolEntry("elinux/printpos/userphone") && settings.readEntry("elinux/user/phone").remove(" ")!="")
    {
	     p.drawText(static_cast<int>((20.0+pageMargLeft)*xrate),static_cast<int>((270.0+pageMargTop+temp_f)*yrate),settings.readEntry ("elinux/user/phone"));
	    temp_f+=20.0;
	    ++temp_i1;
    }
        if(settings.readBoolEntry("elinux/printpos/usermail") && settings.readEntry("elinux/user/email").remove(" ")!="")
    {
	     p.drawText(static_cast<int>((20.0+pageMargLeft)*xrate),static_cast<int>((270.0+pageMargTop+temp_f)*yrate),settings.readEntry ("elinux/user/email"));
	    temp_f+=20.0;
	    ++temp_i1;
    }
        if(settings.readBoolEntry("elinux/printpos/userwww") && settings.readEntry("elinux/user/www").remove(" ")!="")
    {
	     p.drawText(static_cast<int>((20.0+pageMargLeft)*xrate),static_cast<int>((270.0+pageMargTop+temp_f)*yrate),settings.readEntry ("elinux/user/www"));
	    temp_f+=20.0;
	    ++temp_i1;
    }
temp_f=0.0;
    settings.beginGroup ("elinux/printpos");
    QStringList qstringlist=QStringList::split(",",tabletemp.data.client);

    if(qstringlist.size()==8)
    {
	QString temporary="  "+qstringlist[0];
	if( settings.readBoolEntry("clientnazwa") && qstringlist[0].remove(" ")!="")
	{	  
	    p.drawText(static_cast<int>((440.0+pageMargLeft)*xrate),static_cast<int>((270.0+temp_f+pageMargTop)*yrate),temporary);
	    temp_f+=20.0;
	    ++temp_i2;
	}
	temporary=qstringlist[1];
	if( settings.readBoolEntry("clientmiejscowosc") && qstringlist[1].remove(" ")!="")
	{
	    p.drawText(static_cast<int>((440.0+pageMargLeft)*xrate),static_cast<int>((270.0+temp_f+pageMargTop)*yrate),temporary);
	    temp_f+=20.0;
	    ++temp_i2;
	}
	temporary=qstringlist[2];
	if(settings.readBoolEntry("clientadres") && qstringlist[2].remove(" ")!="")
	{
	    p.drawText(static_cast<int>((440.0+pageMargLeft)*xrate),static_cast<int>((270.0+temp_f+pageMargTop)*yrate),temporary);
	    temp_f+=20.0;
	    ++temp_i2;
	}
	temporary=qstringlist[3];
	if(settings.readBoolEntry("clientnip") &&  qstringlist[3].remove(" ").remove("-")!="")
	{
	    p.drawText(static_cast<int>((440.0+pageMargLeft)*xrate),static_cast<int>((270.0+temp_f+pageMargTop)*yrate),tr("  NIP:")+temporary);
	    temp_f+=20.0;
	    ++temp_i2;
	}
	temporary=qstringlist[4];
	if( settings.readBoolEntry("clientkonto") && qstringlist[4].remove(" ").remove("-")!="")
	{
	    p.drawText(static_cast<int>((440.0+pageMargLeft)*xrate),static_cast<int>((270.0+temp_f+pageMargTop)*yrate),tr("  Konto:")+temporary);
	    temp_f+=20.0;
	    ++temp_i2;
	}
	temporary=qstringlist[5];
	if( settings.readBoolEntry("clientphone") && qstringlist[5].remove(" ")!="")
	{
	    p.drawText(static_cast<int>((440.0+pageMargLeft)*xrate),static_cast<int>((270.0+temp_f+pageMargTop)*yrate),tr("  Tel.:")+temporary);
	    temp_f+=20.0;
	    ++temp_i2;
	}
	temporary=qstringlist[6];
	if( settings.readBoolEntry("clientmail") && qstringlist[6].remove(" ")!="")
	{
	    p.drawText(static_cast<int>((440.0+pageMargLeft)*xrate),static_cast<int>((270.0+temp_f+pageMargTop)*yrate),tr("  E-mail:")+temporary);
	    temp_f+=20.0;
	    ++temp_i2;
	}
	temporary=qstringlist[7];
	if( settings.readBoolEntry("clientwww") && qstringlist[7].remove(" ")!="")
	{
	    p.drawText(static_cast<int>((440.0+pageMargLeft)*xrate),static_cast<int>((270.0+temp_f+pageMargTop)*yrate),tr("  www:")+temporary);
	    temp_f+=20.0;
	    ++temp_i2;
	}
     }
    else
    {
	qDebug("Za ilosc danych dla klienta!!! ");
    }
	settings.endGroup ();     
	countPos= ( temp_i1>temp_i2 ? temp_i1 : temp_i2);
        p.drawLine(static_cast<int>((pageMargLeft)*xrate),static_cast<int>((290.0+static_cast<float>(countPos*20)+pageMargTop)*yrate),rect.width()-static_cast<int>(pageMargRight*xrate),static_cast<int>((290.0+static_cast<float>(countPos*20)+pageMargTop)*yrate));


    
    
    

    
    float temp_i=0.0;
    
    float temp_i_height=330.0+static_cast<float>(countPos*20);
    int temp_i_page=0;
    temp_i=315.0+static_cast<float>(countPos*20);
    
    
    // body
    
    p.setFont(QFont("Times",static_cast<int>(8.0*yrate)));
    p.drawLine(static_cast<int>((static_cast<double>(leftColumns[0]))*xrate),static_cast<int>((temp_i+pageMargTop)*yrate),static_cast<int>(static_cast<double>(leftColumns[14])*xrate),static_cast<int>((temp_i+pageMargTop)*yrate));
    if(visibleColumns[0]&&sizeColumns[0]!=0)
	p.drawText(static_cast<int>((static_cast<double>(leftColumns[0])+1)*xrate),static_cast<int>((temp_i_height+pageMargTop)*yrate),tr("Lp."));
    if(visibleColumns[1]&&sizeColumns[1]!=0)
	p.drawText(static_cast<int>((static_cast<double>(leftColumns[1])+1)*xrate),static_cast<int>((temp_i_height+pageMargTop)*yrate),tr("Nazwa"));
    if(visibleColumns[2]&&sizeColumns[2]!=0)
	p.drawText(static_cast<int>((static_cast<double>(leftColumns[2])+1)*xrate),static_cast<int>((temp_i_height+pageMargTop)*yrate),tr("Kod"));
    if(visibleColumns[3]&&sizeColumns[3]!=0)
	p.drawText(static_cast<int>((static_cast<double>(leftColumns[3])+1)*xrate),static_cast<int>((temp_i_height+pageMargTop)*yrate),tr("PKWiU"));
    if(visibleColumns[4]&&sizeColumns[4]!=0)
	p.drawText(static_cast<int>((static_cast<double>(leftColumns[4])+1)*xrate),static_cast<int>((temp_i_height+pageMargTop)*yrate),tr("Ilo"));
    if(visibleColumns[5]&&sizeColumns[5]!=0)
	p.drawText(static_cast<int>((static_cast<double>(leftColumns[5]+1))*xrate),static_cast<int>((temp_i_height+pageMargTop)*yrate),tr("Jm."));
    if(visibleColumns[6]&&sizeColumns[6]!=0)
	p.drawText(static_cast<int>((static_cast<double>(leftColumns[6])+1)*xrate),static_cast<int>((temp_i_height+pageMargTop)*yrate),tr("Cena jdn."));
    if(visibleColumns[7]&&sizeColumns[7]!=0)
    {
	p.drawText(static_cast<int>((static_cast<double>(leftColumns[7])+1)*xrate),static_cast<int>((temp_i_height+pageMargTop+20.0)*yrate),tr("Warto"));
	p.drawText(static_cast<int>((static_cast<double>(leftColumns[7])+1)*xrate),static_cast<int>((temp_i_height+pageMargTop)*yrate),tr("  Netto"));
    }
    if(visibleColumns[8]&&sizeColumns[8]!=0)
    {
	p.drawText(static_cast<int>((static_cast<double>(leftColumns[8])+1)*xrate),static_cast<int>((temp_i_height+pageMargTop)*yrate),tr("Rabat"));
	p.drawText(static_cast<int>((static_cast<double>(leftColumns[8])+1)*xrate),static_cast<int>((temp_i_height+pageMargTop+20.0)*yrate),tr(" [%]"));      
    }
    if(visibleColumns[9]&&sizeColumns[9]!=0)
    {
	p.drawText(static_cast<int>((static_cast<double>(leftColumns[9])+1)*xrate),static_cast<int>((temp_i_height+pageMargTop)*yrate),tr(" Rabat"));
	p.drawText(static_cast<int>((static_cast<double>(leftColumns[9])+1)*xrate),static_cast<int>((temp_i_height+pageMargTop+20.0)*yrate),tr("Warto"));      
    }
    if(visibleColumns[10]&&sizeColumns[10]!=0)
    {
	p.drawText(static_cast<int>((static_cast<double>(leftColumns[10])+1)*xrate),static_cast<int>((temp_i_height+pageMargTop)*yrate),tr(" Netto"));
	p.drawText(static_cast<int>((static_cast<double>(leftColumns[10])+1)*xrate),static_cast<int>((temp_i_height+pageMargTop+20.0)*yrate),tr("po rabacie"));      
    }
    if(visibleColumns[11]&&sizeColumns[11]!=0)
    {
	p.drawText(static_cast<int>((static_cast<double>(leftColumns[11])+1)*xrate),static_cast<int>((temp_i_height+pageMargTop)*yrate),tr("Stawka"));
                p.drawText(static_cast<int>((static_cast<double>(leftColumns[11])+1)*xrate),static_cast<int>((temp_i_height+pageMargTop+20.0)*yrate),tr("VAT[%]"));
    }
    if(visibleColumns[12]&&sizeColumns[12]!=0)
    {
	p.drawText(static_cast<int>((static_cast<double>(leftColumns[12])+1)*xrate),static_cast<int>((temp_i_height+pageMargTop)*yrate),tr("Kwota"));
	p.drawText(static_cast<int>((static_cast<double>(leftColumns[12])+1)*xrate),static_cast<int>((temp_i_height+pageMargTop+20.0)*yrate),tr(" VAT"));      
    }
    if(visibleColumns[13]&&sizeColumns[13]!=0)
    {
	p.drawText(static_cast<int>((static_cast<double>(leftColumns[13])+1)*xrate),static_cast<int>((temp_i_height+pageMargTop)*yrate),tr("Warto"));
                p.drawText(static_cast<int>((static_cast<double>(leftColumns[13])+1)*xrate),static_cast<int>((temp_i_height+pageMargTop+20.0)*yrate),tr(" brutto"));
    }
    
      temp_i_height+=50.0;
  for(unsigned int i=0;i<tabletemp.vec_temp.size();++i)
    {
      if(temp_i_height>(1158-static_cast<int>(pageMargDown)-static_cast<int>(pageMargTop)))
      {
          p.drawLine(static_cast<int>((static_cast<double>(leftColumns[0]))*xrate),static_cast<int>((temp_i+pageMargTop)*yrate),static_cast<int>((static_cast<double>(leftColumns[0])*xrate)),static_cast<int>((temp_i_height+pageMargTop-15.0)*yrate)); 
          p.drawLine(static_cast<int>((static_cast<double>(leftColumns[0]))*xrate),static_cast<int>((temp_i_height+pageMargTop-15.0)*yrate),static_cast<int>((static_cast<double>(leftColumns[14]))*xrate),static_cast<int>((temp_i_height+pageMargTop-15.0)*yrate));    
    if(visibleColumns[1]&&sizeColumns[1]!=0)
	    p.drawLine(static_cast<int>((static_cast<double>(leftColumns[1]))*xrate),static_cast<int>((temp_i+pageMargTop)*yrate),static_cast<int>((static_cast<double>(leftColumns[1]))*xrate),static_cast<int>((temp_i_height+pageMargTop-15)*yrate));    
 
    if(visibleColumns[2]&&sizeColumns[2]!=0)
	    p.drawLine(static_cast<int>((static_cast<double>(leftColumns[2]))*xrate),static_cast<int>((temp_i+pageMargTop)*yrate),static_cast<int>((static_cast<double>(leftColumns[2]))*xrate),static_cast<int>((temp_i_height+pageMargTop-15)*yrate));    
;  
    if(visibleColumns[3]&&sizeColumns[3]!=0)
	    p.drawLine(static_cast<int>((static_cast<double>(leftColumns[3]))*xrate),static_cast<int>((temp_i+pageMargTop)*yrate),static_cast<int>((static_cast<double>(leftColumns[3]))*xrate),static_cast<int>((temp_i_height+pageMargTop-15)*yrate));    
;
    if(visibleColumns[4]&&sizeColumns[4]!=0)
	    p.drawLine(static_cast<int>((static_cast<double>(leftColumns[4]))*xrate),static_cast<int>((temp_i+pageMargTop)*yrate),static_cast<int>((static_cast<double>(leftColumns[4]))*xrate),static_cast<int>((temp_i_height+pageMargTop-15)*yrate));    
;
    if(visibleColumns[5]&&sizeColumns[5]!=0)
	    p.drawLine(static_cast<int>((static_cast<double>(leftColumns[5]))*xrate),static_cast<int>((temp_i+pageMargTop)*yrate),static_cast<int>((static_cast<double>(leftColumns[5]))*xrate),static_cast<int>((temp_i_height+pageMargTop-15)*yrate));    
;  
    if(visibleColumns[6]&&sizeColumns[6]!=0)
	    p.drawLine(static_cast<int>((static_cast<double>(leftColumns[6]))*xrate),static_cast<int>((temp_i+pageMargTop)*yrate),static_cast<int>((static_cast<double>(leftColumns[6]))*xrate),static_cast<int>((temp_i_height+pageMargTop-15)*yrate));    
;
    if(visibleColumns[7]&&sizeColumns[7]!=0)
	    p.drawLine(static_cast<int>((static_cast<double>(leftColumns[7]))*xrate),static_cast<int>((temp_i+pageMargTop)*yrate),static_cast<int>((static_cast<double>(leftColumns[7]))*xrate),static_cast<int>((temp_i_height+pageMargTop-15)*yrate));    
;    
    if(visibleColumns[8]&&sizeColumns[8]!=0)
	    p.drawLine(static_cast<int>((static_cast<double>(leftColumns[8]))*xrate),static_cast<int>((temp_i+pageMargTop)*yrate),static_cast<int>((static_cast<double>(leftColumns[8]))*xrate),static_cast<int>((temp_i_height+pageMargTop-15)*yrate));    
;
    if(visibleColumns[9]&&sizeColumns[9]!=0)
	    p.drawLine(static_cast<int>((static_cast<double>(leftColumns[9]))*xrate),static_cast<int>((temp_i+pageMargTop)*yrate),static_cast<int>((static_cast<double>(leftColumns[9]))*xrate),static_cast<int>((temp_i_height+pageMargTop-15)*yrate));    
;    
    if(visibleColumns[10]&&sizeColumns[10]!=0)
	    p.drawLine(static_cast<int>((static_cast<double>(leftColumns[10]))*xrate),static_cast<int>((temp_i+pageMargTop)*yrate),static_cast<int>((static_cast<double>(leftColumns[10]))*xrate),static_cast<int>((temp_i_height+pageMargTop-15)*yrate));    
;
    if(visibleColumns[11]&&sizeColumns[11]!=0)
	    p.drawLine(static_cast<int>((static_cast<double>(leftColumns[11]))*xrate),static_cast<int>((temp_i+pageMargTop)*yrate),static_cast<int>((static_cast<double>(leftColumns[11]))*xrate),static_cast<int>((temp_i_height+pageMargTop-15)*yrate));    
   
    if(visibleColumns[12]&&sizeColumns[12]!=0)
	    p.drawLine(static_cast<int>((static_cast<double>(leftColumns[12]))*xrate),static_cast<int>((temp_i+pageMargTop)*yrate),static_cast<int>((static_cast<double>(leftColumns[12]))*xrate),static_cast<int>((temp_i_height+pageMargTop-15)*yrate));    

    if(visibleColumns[13]&&sizeColumns[13]!=0)
	    p.drawLine(static_cast<int>((static_cast<double>(leftColumns[13]))*xrate),static_cast<int>((temp_i+pageMargTop)*yrate),static_cast<int>((static_cast<double>(leftColumns[13]))*xrate),static_cast<int>((temp_i_height+pageMargTop-15)*yrate));    
    
    p.drawLine(static_cast<int>(static_cast<double>(leftColumns[14])*xrate),static_cast<int>((temp_i+pageMargTop)*yrate),static_cast<int>(static_cast<double>(leftColumns[14])*xrate),static_cast<int>((temp_i_height+pageMargTop-15.0)*yrate));  

	temp_i=5.0;
	drawPrintSummary(p,temp_i_page);
	++temp_i_page;
	temp_i_height=20.0;
	printer.newPage();
      }
      p.drawLine(static_cast<int>((static_cast<double>(leftColumns[0]))*xrate),static_cast<int>((temp_i_height+pageMargTop-15.0)*yrate),static_cast<int>(static_cast<double>(leftColumns[14])*xrate),static_cast<int>((temp_i_height+pageMargTop-15.0)*yrate));       
    
      int i_temp2=static_cast<int>((temp_i_height+pageMargTop)*yrate);
      if(visibleColumns[0]&&sizeColumns[0]!=0)
	  p.drawText(static_cast<int>(static_cast<double>(leftColumns[0])*xrate),i_temp2,tabletemp.vec_temp[i][0]);
      if(visibleColumns[1]&&sizeColumns[1]!=0)
	  p.drawText(static_cast<int>(static_cast<double>(leftColumns[1])*xrate),i_temp2,tabletemp.vec_temp[i][1]);
      if(visibleColumns[2]&&sizeColumns[2]!=0)
	  p.drawText(static_cast<int>(static_cast<double>(leftColumns[2])*xrate),i_temp2,tabletemp.vec_temp[i][2]);
      if(visibleColumns[3]&&sizeColumns[3]!=0)
	  p.drawText(static_cast<int>(static_cast<double>(leftColumns[3])*xrate),i_temp2,tabletemp.vec_temp[i][3]);
      if(visibleColumns[4]&&sizeColumns[4]!=0)
	  p.drawText(static_cast<int>(static_cast<double>(leftColumns[4])*xrate),i_temp2,tabletemp.vec_temp[i][4]);
      if(visibleColumns[5]&&sizeColumns[5]!=0)
	  p.drawText(static_cast<int>(static_cast<double>(leftColumns[5])*xrate),i_temp2,tabletemp.vec_temp[i][5]);
      if(visibleColumns[6]&&sizeColumns[6]!=0)
	  p.drawText(static_cast<int>(static_cast<double>(leftColumns[6])*xrate),i_temp2,tabletemp.vec_temp[i][6]);
      if(visibleColumns[7]&&sizeColumns[7]!=0)
	  p.drawText(static_cast<int>(static_cast<double>(leftColumns[7])*xrate),i_temp2,tabletemp.vec_temp[i][7]);
      if(visibleColumns[8]&&sizeColumns[8]!=0)
	  p.drawText(static_cast<int>(static_cast<double>(leftColumns[8])*xrate),i_temp2,tabletemp.vec_temp[i][8]);
      if(visibleColumns[9]&&sizeColumns[9]!=0)
	  p.drawText(static_cast<int>(static_cast<double>(leftColumns[9])*xrate),i_temp2,tabletemp.vec_temp[i][9]);
      if(visibleColumns[10]&&sizeColumns[10]!=0)
	  p.drawText(static_cast<int>(static_cast<double>(leftColumns[10])*xrate),i_temp2,tabletemp.vec_temp[i][10]);
      if(visibleColumns[11]&&sizeColumns[11]!=0)
	  p.drawText(static_cast<int>(static_cast<double>(leftColumns[11])*xrate),i_temp2,tabletemp.vec_temp[i][11]);
      if(visibleColumns[12]&&sizeColumns[12]!=0)
	  p.drawText(static_cast<int>(static_cast<double>(leftColumns[12])*xrate),i_temp2,tabletemp.vec_temp[i][12]);
      if(visibleColumns[13]&&sizeColumns[13]!=0)
	  p.drawText(static_cast<int>(static_cast<double>(leftColumns[13])*xrate),i_temp2,tabletemp.vec_temp[i][13]);
      temp_i_height+=20.0;
    }
    
    
          p.drawLine(static_cast<int>((static_cast<double>(leftColumns[0]))*xrate),static_cast<int>((temp_i+pageMargTop)*yrate),static_cast<int>(static_cast<double>(leftColumns[0])*xrate),static_cast<int>((temp_i_height+pageMargTop-15.0)*yrate));  
    
    if(visibleColumns[1]&&sizeColumns[1]!=0)
	    p.drawLine(static_cast<int>((static_cast<double>(leftColumns[1]))*xrate),static_cast<int>((temp_i+pageMargTop)*yrate),static_cast<int>((static_cast<double>(leftColumns[1]))*xrate),static_cast<int>((temp_i_height+pageMargTop-15)*yrate));    
 
    if(visibleColumns[2]&&sizeColumns[2]!=0)
	    p.drawLine(static_cast<int>((static_cast<double>(leftColumns[2]))*xrate),static_cast<int>((temp_i+pageMargTop)*yrate),static_cast<int>((static_cast<double>(leftColumns[2]))*xrate),static_cast<int>((temp_i_height+pageMargTop-15)*yrate));    
;  
    if(visibleColumns[3]&&sizeColumns[3]!=0)
	    p.drawLine(static_cast<int>((static_cast<double>(leftColumns[3]))*xrate),static_cast<int>((temp_i+pageMargTop)*yrate),static_cast<int>((static_cast<double>(leftColumns[3]))*xrate),static_cast<int>((temp_i_height+pageMargTop-15)*yrate));    
;
    if(visibleColumns[4]&&sizeColumns[4]!=0)
	    p.drawLine(static_cast<int>((static_cast<double>(leftColumns[4]))*xrate),static_cast<int>((temp_i+pageMargTop)*yrate),static_cast<int>((static_cast<double>(leftColumns[4]))*xrate),static_cast<int>((temp_i_height+pageMargTop-15)*yrate));    
;
    if(visibleColumns[5]&&sizeColumns[5]!=0)
	    p.drawLine(static_cast<int>((static_cast<double>(leftColumns[5]))*xrate),static_cast<int>((temp_i+pageMargTop)*yrate),static_cast<int>((static_cast<double>(leftColumns[5]))*xrate),static_cast<int>((temp_i_height+pageMargTop-15)*yrate));    
;  
    if(visibleColumns[6]&&sizeColumns[6]!=0)
	    p.drawLine(static_cast<int>((static_cast<double>(leftColumns[6]))*xrate),static_cast<int>((temp_i+pageMargTop)*yrate),static_cast<int>((static_cast<double>(leftColumns[6]))*xrate),static_cast<int>((temp_i_height+pageMargTop-15)*yrate));    
;
    if(visibleColumns[7]&&sizeColumns[7]!=0)
	    p.drawLine(static_cast<int>((static_cast<double>(leftColumns[7]))*xrate),static_cast<int>((temp_i+pageMargTop)*yrate),static_cast<int>((static_cast<double>(leftColumns[7]))*xrate),static_cast<int>((temp_i_height+pageMargTop-15)*yrate));    
;    
    if(visibleColumns[8]&&sizeColumns[8]!=0)
	    p.drawLine(static_cast<int>((static_cast<double>(leftColumns[8]))*xrate),static_cast<int>((temp_i+pageMargTop)*yrate),static_cast<int>((static_cast<double>(leftColumns[8]))*xrate),static_cast<int>((temp_i_height+pageMargTop-15)*yrate));    
;
    if(visibleColumns[9]&&sizeColumns[9]!=0)
	    p.drawLine(static_cast<int>((static_cast<double>(leftColumns[9]))*xrate),static_cast<int>((temp_i+pageMargTop)*yrate),static_cast<int>((static_cast<double>(leftColumns[9]))*xrate),static_cast<int>((temp_i_height+pageMargTop-15)*yrate));    
;    
    if(visibleColumns[10]&&sizeColumns[10]!=0)
	    p.drawLine(static_cast<int>((static_cast<double>(leftColumns[10]))*xrate),static_cast<int>((temp_i+pageMargTop)*yrate),static_cast<int>((static_cast<double>(leftColumns[10]))*xrate),static_cast<int>((temp_i_height+pageMargTop-15)*yrate));    
;
    if(visibleColumns[11]&&sizeColumns[11]!=0)
	    p.drawLine(static_cast<int>((static_cast<double>(leftColumns[11]))*xrate),static_cast<int>((temp_i+pageMargTop)*yrate),static_cast<int>((static_cast<double>(leftColumns[11]))*xrate),static_cast<int>((temp_i_height+pageMargTop-15)*yrate));    
   
    if(visibleColumns[12]&&sizeColumns[12]!=0)
	    p.drawLine(static_cast<int>((static_cast<double>(leftColumns[12]))*xrate),static_cast<int>((temp_i+pageMargTop)*yrate),static_cast<int>((static_cast<double>(leftColumns[12]))*xrate),static_cast<int>((temp_i_height+pageMargTop-15)*yrate));    

    if(visibleColumns[13]&&sizeColumns[13]!=0)
	    p.drawLine(static_cast<int>((static_cast<double>(leftColumns[13]))*xrate),static_cast<int>((temp_i+pageMargTop)*yrate),static_cast<int>((static_cast<double>(leftColumns[13]))*xrate),static_cast<int>((temp_i_height+pageMargTop-15)*yrate));    
    
    p.drawLine(static_cast<int>(static_cast<double>(leftColumns[14])*xrate),static_cast<int>((temp_i+pageMargTop)*yrate),static_cast<int>(static_cast<double>(leftColumns[14])*xrate),static_cast<int>((temp_i_height+pageMargTop-15.0)*yrate));  
    
    p.drawLine(static_cast<int>((static_cast<double>(leftColumns[0]))*xrate),static_cast<int>((temp_i_height+pageMargTop-15.0)*yrate),static_cast<int>((static_cast<double>(leftColumns[14]))*xrate),static_cast<int>((temp_i_height+pageMargTop-15.0)*yrate));
    
  
   
    
      if(temp_i_height>(1058-margDown-margTop))
      {
	drawPrintSummary(p,temp_i_page);	  
	++temp_i_page;	
	temp_i_height=20.0;
	printer.newPage();
      }
      
                temp_i_height+=30.0;
                p.drawText(static_cast<int>((510.0+pageMargLeft)*xrate),static_cast<int>((temp_i_height+pageMargTop-25.0)*yrate),tr("Razem:"));
	p.drawText(static_cast<int>((550.0+pageMargLeft)*xrate),static_cast<int>((temp_i_height+pageMargTop-25.0)*yrate),tr("Warto"));
	p.drawText(static_cast<int>((550.0+pageMargLeft)*xrate),static_cast<int>((temp_i_height+pageMargTop-12.0)*yrate),tr("Netto"));
	p.drawText(static_cast<int>((600.0+pageMargLeft)*xrate),static_cast<int>((temp_i_height+pageMargTop-25.0)*yrate),tr("Kwota"));
	p.drawText(static_cast<int>((600.0+pageMargLeft)*xrate),static_cast<int>((temp_i_height+pageMargTop-12.0)*yrate),tr("VAT"));      
	p.drawText(static_cast<int>((655.0+pageMargLeft)*xrate),static_cast<int>((temp_i_height+pageMargTop-25.0)*yrate),tr("Warto"));
	p.drawText(static_cast<int>((655.0+pageMargLeft)*xrate),static_cast<int>((temp_i_height+pageMargTop-12.0)*yrate),tr("Brutto"));
	
      p.drawText(static_cast<int>((550.0+pageMargLeft)*xrate),static_cast<int>((temp_i_height+pageMargTop)*yrate),tabletemp.data.netto);
      p.drawText(static_cast<int>((600.0+pageMargLeft)*xrate),static_cast<int>((temp_i_height+pageMargTop)*yrate),tabletemp.data.vat);
      p.drawText(static_cast<int>((655.0+pageMargLeft)*xrate),static_cast<int>((temp_i_height+pageMargTop)*yrate),tabletemp.data.brutto);
      temp_i_height+=50.0;
      
      if((temp_i_height+120)>(1058-margDown-margTop))
      {
	drawPrintSummary(p,temp_i_page);	  
	++temp_i_page;
	temp_i_height=20.0;
	printer.newPage();
    }
      p.setFont(QFont("Times",static_cast<int>(14.0*yrate),75));
      p.drawText(static_cast<int>((20.0+pageMargLeft)*xrate),static_cast<int>((temp_i_height+pageMargTop)*yrate),tr("Do zapaty: ")+tabletemp.data.sum);
      p.setFont(QFont("Times",static_cast<int>(8.0*yrate),50));
      p.drawText(static_cast<int>((20.0+pageMargLeft)*xrate),static_cast<int>((temp_i_height+pageMargTop+20.0)*yrate),tr("Kwota sownie: ")+tabletemp.data.sumStr);
      p.drawText(static_cast<int>((20.0+pageMargLeft)*xrate),static_cast<int>((temp_i_height+pageMargTop+40.0)*yrate),tr("Forma patnoci: ")+tabletemp.data.payMode);
      p.drawText(static_cast<int>((20.0+pageMargLeft)*xrate),static_cast<int>((temp_i_height+pageMargTop+60)*yrate),tr("Termin patnoci: ")+tabletemp.data.payDate);
      if(tabletemp.data.paidCash==true)
      {
         p.drawText(static_cast<int>((20.0+pageMargLeft)*xrate),static_cast<int>((temp_i_height+pageMargTop+80)*yrate),tr("Zapacono gotwk"));
      }
      else
      {
        p.drawText(static_cast<int>((20.0+pageMargLeft)*xrate),static_cast<int>((temp_i_height+pageMargTop+80)*yrate),tr("Zapata przelewem"));  
      }
      p.setFont(QFont("Times",static_cast<int>(14.0*yrate),75));
      p.drawText(static_cast<int>((20.0+pageMargLeft)*xrate),static_cast<int>((temp_i_height+pageMargTop+100)*yrate),tabletemp.data.additText);  
      
      p.drawText(static_cast<int>((380.0+pageMargLeft)*xrate),static_cast<int>((temp_i_height+pageMargTop-20)*yrate),tr("Oglnie stawkami"));
      p.setFont(QFont("Times",static_cast<int>(8.0*yrate),50));
      
      p.drawText(static_cast<int>((400.0+pageMargLeft)*xrate),static_cast<int>((temp_i_height+pageMargTop)*yrate),tr("Netto"));
      p.drawText(static_cast<int>((450.0+pageMargLeft)*xrate),static_cast<int>((temp_i_height+pageMargTop)*yrate),tr("Stawka"));
      p.drawText(static_cast<int>((500.0+pageMargLeft)*xrate),static_cast<int>((temp_i_height+pageMargTop)*yrate),tr("Podatek"));
      p.drawText(static_cast<int>((550.0+pageMargLeft)*xrate),static_cast<int>((temp_i_height+pageMargTop)*yrate),tr("Brutto"));
      QStringList bidsList=QStringList::split(";",tabletemp.data.Bids);
      temp_i_height+=20.0;
      QStringList::Iterator it = bidsList.begin();
      for(int i=0;i<4;++i)
	  for(int j=0;j<4;++j)
	  {
	      p.drawText(static_cast<int>((400.0+pageMargLeft+static_cast<float>(j)*50.0)*xrate),static_cast<int>((temp_i_height+pageMargTop+static_cast<float>(i)*20)*yrate),*it);
	      ++it;
	  }
      temp_i_height+=130.0;
      
      if((temp_i_height+100)>(1058-margDown-margTop))
      {
	drawPrintSummary(p,temp_i_page);	  
	++temp_i_page;
	temp_i_height=20.0;
	printer.newPage();
      }      
      temp_i_height+=50.0;
      p.drawLine(static_cast<int>((pageMargLeft+50.0)*xrate),static_cast<int>((temp_i_height+pageMargTop)*yrate),static_cast<int>((pageMargLeft+300.0)*xrate),static_cast<int>((temp_i_height+pageMargTop)*yrate));
      
      p.drawLine(static_cast<int>((pageMargLeft+400.0)*xrate),static_cast<int>((temp_i_height+pageMargTop)*yrate),static_cast<int>((pageMargLeft+650.0)*xrate),static_cast<int>((temp_i_height+pageMargTop)*yrate));
      p.setFont(QFont("Times",static_cast<int>(6.0*yrate),50));
      
#ifdef QF_base__
      //qDebug("aaa");
      p.drawText(static_cast<int>((pageMargLeft+80.0)*xrate),static_cast<int>((temp_i_height+pageMargTop+10.0)*yrate),tr("Imi i nazwisko osoby upowanionej do wystawienia faktury VAT"));
      p.drawText(static_cast<int>((pageMargLeft+440.0)*xrate),static_cast<int>((temp_i_height+pageMargTop+10.0)*yrate),tr("Imi i nazwisko osoby upowanionej do odbioru faktury VAT"));
#endif

#ifdef QF_vatmp__
      p.drawText(static_cast<int>((pageMargLeft+80.0)*xrate),static_cast<int>((temp_i_height+pageMargTop+10.0)*yrate),tr("Imi i nazwisko osoby upowanionej do wystawienia faktury VAT"));
      p.drawText(static_cast<int>((pageMargLeft+440.0)*xrate),static_cast<int>((temp_i_height+pageMargTop+10.0)*yrate),tr("Imi i nazwisko osoby upowanionej do odbioru faktury VAT"));

#endif

#ifdef QF_noVAT__
      p.drawText(static_cast<int>((pageMargLeft+80.0)*xrate),static_cast<int>((temp_i_height+pageMargTop+10.0)*yrate),tr("Imi i nazwisko osoby upowanionej do wystawienia rachunku"));
      p.drawText(static_cast<int>((pageMargLeft+440.0)*xrate),static_cast<int>((temp_i_height+pageMargTop+10.0)*yrate),tr("Imi i nazwisko osoby upowanionej do odbioru rachunku"));
#endif      
  drawPrintSummary(p,temp_i_page);
  p.end();
   }
}


void PrintPreview::canCel()
{
    this->close();
}



void PrintPreview::drawBody()
{
 //   qDebug("drawbody"+QString::number(tabletemp.vec_temp.size()));
    int temp_i_height=330+countPos*20,temp_i_page=0,temp_i=315+countPos*20;
    
    QPainter p;
    if(makePdf)
	p.begin(&pixmap_pdf[0]);
    else
	p.begin(&pixmap[0]);	
    p.setFont(QFont("Times",8*scale));
    p.drawLine(leftColumns[0]*scale,(temp_i_height+margTop-15)*scale,leftColumns[14]*scale,(temp_i_height+margTop-15)*scale);
    if(visibleColumns[0] && sizeColumns[0]!=0)
	p.drawText((leftColumns[0]+1)*scale,(temp_i_height+margTop)*scale,tr("Lp."));
    if(visibleColumns[1]  && sizeColumns[1]!=0)
	p.drawText((leftColumns[1]+1)*scale,(temp_i_height+margTop)*scale,tr("Nazwa"));
    if(visibleColumns[2] && sizeColumns[2]!=0)
	p.drawText((leftColumns[2]+1)*scale,(temp_i_height+margTop)*scale,tr("Kod"));
    if(visibleColumns[3] && sizeColumns[3]!=0)
	p.drawText((leftColumns[3]+1)*scale,(temp_i_height+margTop)*scale,tr("PKWiU"));
    if(visibleColumns[4] && sizeColumns[4]!=0)
	p.drawText((leftColumns[4]+1)*scale,(temp_i_height+margTop)*scale,tr("Ilo"));
    if(visibleColumns[5]  && sizeColumns[5]!=0)
	p.drawText((leftColumns[5]+1)*scale,(temp_i_height+margTop)*scale,tr("Jm."));
    if(visibleColumns[6]  && sizeColumns[6]!=0)
	p.drawText((leftColumns[6]+1)*scale,(temp_i_height+margTop)*scale,tr("Cena jdn."));
    if(visibleColumns[7] && sizeColumns[7]!=0)
    {
	p.drawText((leftColumns[7]+1)*scale,(temp_i_height+margTop+20)*scale,tr("Warto"));
	p.drawText((leftColumns[7]+1)*scale,(temp_i_height+margTop)*scale,tr("  Netto"));
    }
    if(visibleColumns[8] && sizeColumns[8]!=0)
    {
	p.drawText((leftColumns[8]+1)*scale,(temp_i_height+margTop)*scale,tr("Rabat"));
	p.drawText((leftColumns[8]+1)*scale,(temp_i_height+margTop+20)*scale,tr(" [%]"));      
    }
    if(visibleColumns[9] && sizeColumns[9]!=0)
    {
	p.drawText((leftColumns[9]+1)*scale,(temp_i_height+margTop+20)*scale,tr(" Rabat"));
	p.drawText((leftColumns[9]+1)*scale,(temp_i_height+margTop)*scale,tr("Warto"));      
    }
    if(visibleColumns[10] && sizeColumns[10]!=0)
    {
	p.drawText((leftColumns[10]+1)*scale,(temp_i_height+margTop)*scale,tr(" Netto"));
	p.drawText((leftColumns[10]+1)*scale,(temp_i_height+margTop+20)*scale,tr("po rabacie"));      
    }
    if(visibleColumns[11] && sizeColumns[1]!=0)
    {
	p.drawText((leftColumns[11]+1)*scale,(temp_i_height+margTop)*scale,tr("Stawka"));
                p.drawText((leftColumns[11]+1)*scale,(temp_i_height+margTop+20)*scale,tr("VAT[%]"));
    }
    if(visibleColumns[12] && sizeColumns[12]!=0)
    {
	p.drawText((leftColumns[12]+1)*scale,(temp_i_height+margTop)*scale,tr("Kwota"));
	p.drawText((leftColumns[12]+1)*scale,(temp_i_height+margTop+20)*scale,tr(" VAT"));      
    }
    if(visibleColumns[13]  && sizeColumns[13]!=0)
    {
	p.drawText((leftColumns[13]+1)*scale,(temp_i_height+margTop)*scale,tr("Warto"));
                p.drawText((leftColumns[13]+1)*scale,(temp_i_height+margTop+20)*scale,tr(" brutto"));
    }
      temp_i_height+=50;
  for(unsigned int i=0;i<tabletemp.vec_temp.size();++i)
    {
      if(temp_i_height>(pixmap[temp_i_page].height()-margDown-30-margTop))
      {
    p.drawLine((leftColumns[0])*scale,(temp_i_height+margTop-15)*scale,(leftColumns[14])*scale,(temp_i_height+margTop-15)*scale);    
    p.drawLine((leftColumns[0])*scale,(temp_i+margTop)*scale,(leftColumns[0])*scale,(temp_i_height+margTop-15)*scale);    
    if(visibleColumns[1] &&sizeColumns[1]!=0)
	p.drawLine((leftColumns[1])*scale,(temp_i+margTop)*scale,(leftColumns[1])*scale,(temp_i_height+margTop-15)*scale);    
    if(visibleColumns[2] && sizeColumns[2]!=0)
	p.drawLine((leftColumns[2])*scale,(temp_i+margTop)*scale,(leftColumns[2])*scale,(temp_i_height+margTop-15)*scale);  
    if(visibleColumns[3] && sizeColumns[3]!=0)
	p.drawLine((leftColumns[3])*scale,(temp_i+margTop)*scale,(leftColumns[3])*scale,(temp_i_height+margTop-15)*scale);
    if(visibleColumns[4] && sizeColumns[4]!=0)
	p.drawLine((leftColumns[4])*scale,(temp_i+margTop)*scale,(leftColumns[4])*scale,(temp_i_height+margTop-15)*scale);
    if(visibleColumns[5] && sizeColumns[5]!=0)
	p.drawLine((leftColumns[5])*scale,(temp_i+margTop)*scale,(leftColumns[5])*scale,(temp_i_height+margTop-15)*scale);  
    if(visibleColumns[6] && sizeColumns[6]!=0)
	p.drawLine((leftColumns[6])*scale,(temp_i+margTop)*scale,(leftColumns[6])*scale,(temp_i_height+margTop-15)*scale);
    if(visibleColumns[7] && sizeColumns[7]!=0)
	p.drawLine((leftColumns[7])*scale,(temp_i+margTop)*scale,(leftColumns[7])*scale,(temp_i_height+margTop-15)*scale);    
    if(visibleColumns[8] &&sizeColumns[8]!=0)
	p.drawLine((leftColumns[8])*scale,(temp_i+margTop)*scale,(leftColumns[8])*scale,(temp_i_height+margTop-15)*scale);
    if(visibleColumns[9] &&sizeColumns[9]!=0)
	p.drawLine((leftColumns[9])*scale,(temp_i+margTop)*scale,(leftColumns[9])*scale,(temp_i_height+margTop-15)*scale);    
    if(visibleColumns[10] &&sizeColumns[10]!=0)
	p.drawLine((leftColumns[10])*scale,(temp_i+margTop)*scale,(leftColumns[10])*scale,(temp_i_height+margTop-15)*scale);
    if(visibleColumns[11] &&sizeColumns[11]!=0)
	p.drawLine((leftColumns[11])*scale,(temp_i+margTop)*scale,(leftColumns[11])*scale,(temp_i_height+margTop-15)*scale);   
    if(visibleColumns[12] &&sizeColumns[12]!=0)
	p.drawLine((leftColumns[12])*scale,(temp_i+margTop)*scale,(leftColumns[12])*scale,(temp_i_height+margTop-15)*scale);
    if(visibleColumns[13] &&sizeColumns[13]!=0)
	p.drawLine((leftColumns[13])*scale,(temp_i+margTop)*scale,(leftColumns[13])*scale,(temp_i_height+margTop-15)*scale);
    p.drawLine((leftColumns[14])*scale,(temp_i+margTop)*scale,(leftColumns[14])*scale,(temp_i_height+margTop-15)*scale);  
	temp_i=5;
	++temp_i_page;
	temp_i_height=20;
	p.end();
	if(makePdf)
	{
	pixmap_pdf.push_back(QPixmap(840*scale,1188*scale));
	pixmap_pdf[temp_i_page].fill();
	p.begin(&pixmap_pdf[temp_i_page]);
               }
	else
	{
	pixmap.push_back(QPixmap(840,1188));
	pixmap[temp_i_page].fill();
	p.begin(&pixmap[temp_i_page]);
	    
	}
      }
      p.drawLine((leftColumns[0])*scale,(temp_i_height+margTop-15)*scale,(leftColumns[14])*scale,(temp_i_height+margTop-15)*scale);      
      if(visibleColumns[0] &&sizeColumns[0]!=0)
	  p.drawText((leftColumns[0]+1)*scale,(temp_i_height+margTop)*scale,tabletemp.vec_temp[i][0]);
      if(visibleColumns[1] &&sizeColumns[1]!=0)
	  p.drawText((leftColumns[1]+1)*scale,(temp_i_height+margTop)*scale,tabletemp.vec_temp[i][1]);
      if(visibleColumns[2] &&sizeColumns[2]!=0)
	  p.drawText((leftColumns[2]+1)*scale,(temp_i_height+margTop)*scale,tabletemp.vec_temp[i][2]);
      if(visibleColumns[3] &&sizeColumns[3]!=0)
	  p.drawText((leftColumns[3]+1)*scale,(temp_i_height+margTop)*scale,tabletemp.vec_temp[i][3]);
      if(visibleColumns[4] &&sizeColumns[4]!=0)
	  p.drawText((leftColumns[4]+1)*scale,(temp_i_height+margTop)*scale,tabletemp.vec_temp[i][4]);
      if(visibleColumns[5] &&sizeColumns[5]!=0)
	  p.drawText((leftColumns[5]+1)*scale,(temp_i_height+margTop)*scale,tabletemp.vec_temp[i][5]);
      if(visibleColumns[6] &&sizeColumns[6]!=0)
	  p.drawText((leftColumns[6]+1)*scale,(temp_i_height+margTop)*scale,tabletemp.vec_temp[i][6]);
      if(visibleColumns[7] &&sizeColumns[7]!=0)
	  p.drawText((leftColumns[7]+1)*scale,(temp_i_height+margTop)*scale,tabletemp.vec_temp[i][7]);
      if(visibleColumns[8] &&sizeColumns[8]!=0)
	  p.drawText((leftColumns[8]+1)*scale,(temp_i_height+margTop)*scale,tabletemp.vec_temp[i][8]);
      if(visibleColumns[9] &&sizeColumns[9]!=0)
	  p.drawText((leftColumns[9]+1)*scale,(temp_i_height+margTop)*scale,tabletemp.vec_temp[i][9]);
      if(visibleColumns[10] &&sizeColumns[10]!=0)
	  p.drawText((leftColumns[10]+1)*scale,(temp_i_height+margTop)*scale,tabletemp.vec_temp[i][10]);
      if(visibleColumns[11] &&sizeColumns[11]!=0)
	  p.drawText((leftColumns[11]+1)*scale,(temp_i_height+margTop)*scale,tabletemp.vec_temp[i][11]);
      if(visibleColumns[12] &&sizeColumns[12]!=0)
	  p.drawText((leftColumns[12]+1)*scale,(temp_i_height+margTop)*scale,tabletemp.vec_temp[i][12]);
      if(visibleColumns[13] &&sizeColumns[13]!=0)
	  p.drawText((leftColumns[13]+1)*scale,(temp_i_height+margTop)*scale,tabletemp.vec_temp[i][13]);
      temp_i_height+=20;
    }
    p.drawLine((leftColumns[0])*scale,(temp_i+margTop)*scale,(leftColumns[0])*scale,(temp_i_height+margTop-15)*scale);    
    p.drawLine((leftColumns[0])*scale,(temp_i_height+margTop-15)*scale,(leftColumns[14])*scale,(temp_i_height+margTop-15)*scale);      
    if(visibleColumns[1] &&sizeColumns[1]!=0)
	p.drawLine((leftColumns[1])*scale,(temp_i+margTop)*scale,(leftColumns[1])*scale,(temp_i_height+margTop-15)*scale);    
    if(visibleColumns[2] &&sizeColumns[2]!=0)
	p.drawLine((leftColumns[2])*scale,(temp_i+margTop)*scale,(leftColumns[2])*scale,(temp_i_height+margTop-15)*scale);  
    if(visibleColumns[3] &&sizeColumns[3]!=0)
	p.drawLine((leftColumns[3])*scale,(temp_i+margTop)*scale,(leftColumns[3])*scale,(temp_i_height+margTop-15)*scale);
    if(visibleColumns[4] &&sizeColumns[4]!=0)
	p.drawLine((leftColumns[4])*scale,(temp_i+margTop)*scale,(leftColumns[4])*scale,(temp_i_height+margTop-15)*scale);
    if(visibleColumns[5] &&sizeColumns[5]!=0)
	p.drawLine((leftColumns[5])*scale,(temp_i+margTop)*scale,(leftColumns[5])*scale,(temp_i_height+margTop-15)*scale);  
    if(visibleColumns[6] &&sizeColumns[6]!=0)
	p.drawLine((leftColumns[6])*scale,(temp_i+margTop)*scale,(leftColumns[6])*scale,(temp_i_height+margTop-15)*scale);
    if(visibleColumns[7] &&sizeColumns[7]!=0)
	p.drawLine((leftColumns[7])*scale,(temp_i+margTop)*scale,(leftColumns[7])*scale,(temp_i_height+margTop-15)*scale);    
    if(visibleColumns[8] &&sizeColumns[8]!=0)
	p.drawLine((leftColumns[8])*scale,(temp_i+margTop)*scale,(leftColumns[8])*scale,(temp_i_height+margTop-15)*scale);
    if(visibleColumns[9] &&sizeColumns[9]!=0)
	p.drawLine((leftColumns[9])*scale,(temp_i+margTop)*scale,(leftColumns[9])*scale,(temp_i_height+margTop-15)*scale);    
    if(visibleColumns[10] &&sizeColumns[10]!=0)
	p.drawLine((leftColumns[10])*scale,(temp_i+margTop)*scale,(leftColumns[10])*scale,(temp_i_height+margTop-15)*scale);
    if(visibleColumns[11] &&sizeColumns[11]!=0)
	p.drawLine((leftColumns[11])*scale,(temp_i+margTop)*scale,(leftColumns[11])*scale,(temp_i_height+margTop-15)*scale);   
    if(visibleColumns[12] &&sizeColumns[12]!=0)
	p.drawLine((leftColumns[12])*scale,(temp_i+margTop)*scale,(leftColumns[12])*scale,(temp_i_height+margTop-15)*scale);
    if(visibleColumns[13] &&sizeColumns[13]!=0)
	p.drawLine((leftColumns[13])*scale,(temp_i+margTop)*scale,(leftColumns[13])*scale,(temp_i_height+margTop-15)*scale);
    
    p.drawLine((leftColumns[14])*scale,(temp_i+margTop)*scale,(leftColumns[14])*scale,(temp_i_height+margTop-15)*scale);      
      if(temp_i_height>(pixmap[temp_i_page].height()-margDown-30-margTop))
      {
	++temp_i_page;
	temp_i_height=20;
	p.end();
	if(makePdf)
	{
	pixmap_pdf.push_back(QPixmap(840*scale,1188*scale));
	pixmap_pdf[temp_i_page].fill();
	p.begin(&pixmap_pdf[temp_i_page]);
                }
	else
	{
	pixmap.push_back(QPixmap(840,1188));
	pixmap[temp_i_page].fill();
	p.begin(&pixmap[temp_i_page]);
	}
      }
                temp_i_height+=30;
                p.drawText((500+margLeft)*scale,(temp_i_height+margTop-25)*scale,tr("Razem:"));
	p.drawText((545+margLeft)*scale,(temp_i_height+margTop-25)*scale,tr("Warto"));
	p.drawText((545+margLeft)*scale,(temp_i_height+margTop-12)*scale,tr("Netto"));
	p.drawText((600+margLeft)*scale,(temp_i_height+margTop-25)*scale,tr("Kwota"));
	p.drawText((600+margLeft)*scale,(temp_i_height+margTop-12)*scale,tr("VAT"));      
	p.drawText((655+margLeft)*scale,(temp_i_height+margTop-25)*scale,tr("Warto"));
	p.drawText((655+margLeft)*scale,(temp_i_height+margTop-12)*scale,tr("Brutto"));
      
      
      p.drawText((545+margLeft)*scale,(temp_i_height+margTop+10)*scale,tabletemp.data.netto);
      p.drawText((600+margLeft)*scale,(temp_i_height+margTop+10)*scale,tabletemp.data.vat);
      p.drawText((655+margLeft)*scale,(temp_i_height+margTop+10)*scale,tabletemp.data.brutto);
      temp_i_height+=60;
      if((temp_i_height+120)>(pixmap[temp_i_page].height()-margDown-30-margTop))
      {
	++temp_i_page;
	temp_i_height=20;
	p.end();
	if(makePdf)
	{
	pixmap_pdf.push_back(QPixmap(840*scale,1188*scale));
	pixmap_pdf[temp_i_page].fill();
	p.begin(&pixmap_pdf[temp_i_page]);
                }
	else
	{
	pixmap.push_back(QPixmap(840,1188));
	pixmap[temp_i_page].fill();
	p.begin(&pixmap[temp_i_page]);
	}
      }
      p.setFont(QFont("Times",14*scale,75));
      p.drawText((20+margLeft)*scale,(temp_i_height+margTop)*scale,tr("Do zapaty: ")+tabletemp.data.sum);
      p.setFont(QFont("Times",8*scale,50));
      p.drawText((20+margLeft)*scale,(temp_i_height+margTop+20)*scale,tr("Kwota sownie: ")+tabletemp.data.sumStr);
      p.drawText((20+margLeft)*scale,(temp_i_height+margTop+40)*scale,tr("Forma patnoci: ")+tabletemp.data.payMode);
      p.drawText((20+margLeft)*scale,(temp_i_height+margTop+60)*scale,tr("Termin patnoci: ")+tabletemp.data.payDate);
      if(tabletemp.data.paidCash==true)
      {
         p.drawText((20+margLeft)*scale,(temp_i_height+margTop+80)*scale,tr("Zapacono gotwk"));
      }
      else
      {
        p.drawText((20+margLeft),(temp_i_height+margTop+80)*scale,tr("Zapata przelewem"));  
      }
      p.setFont(QFont("Times",14*scale,75));
      p.drawText((20+margLeft)*scale,(temp_i_height+margTop+100)*scale,tabletemp.data.additText);  
      p.drawText((380+margLeft)*scale,(temp_i_height+margTop-20)*scale,tr("Oglnie stawkami"));
      p.setFont(QFont("Times",8*scale,50));
      p.drawText((400+margLeft)*scale,(temp_i_height+margTop)*scale,tr("Netto"));
      p.drawText((450+margLeft)*scale,(temp_i_height+margTop)*scale,tr("Stawka"));
      p.drawText((500+margLeft)*scale,(temp_i_height+margTop)*scale,tr("Podatek"));
      p.drawText((550+margLeft)*scale,(temp_i_height+margTop)*scale,tr("Brutto"));
      QStringList bidsList=QStringList::split(";",tabletemp.data.Bids);
      temp_i_height+=20;
      QStringList::Iterator it = bidsList.begin();
      for(int i=0;i<4;++i)
	  for(int j=0;j<4;++j)
	  {
	      p.drawText((400+margLeft+j*50)*scale,(temp_i_height+margTop+i*20)*scale,*it);
	      ++it;
	  }
      temp_i_height+=130;
      if((temp_i_height+100)>(pixmap[temp_i_page].height()-margDown-30-margTop))
      {
++temp_i_page;
	temp_i_height=20;
	p.end();
	if(makePdf)
	{
	pixmap_pdf.push_back(QPixmap(840*scale,1188*scale));
	pixmap_pdf[temp_i_page].fill();
	p.begin(&pixmap_pdf[temp_i_page]);
                }
	else
	{
	pixmap.push_back(QPixmap(840,1188));
	pixmap[temp_i_page].fill();
	p.begin(&pixmap[temp_i_page]);
	}
      }      
      temp_i_height+=50;
      p.drawLine((margLeft+50)*scale,(temp_i_height+margTop)*scale,(margLeft+300)*scale,(temp_i_height+margTop)*scale);
      p.drawLine((margLeft+400)*scale,(temp_i_height+margTop)*scale,(margLeft+650)*scale,(temp_i_height+margTop)*scale);
      p.setFont(QFont("Times",6*scale,50));
  
#ifdef QF_base__
      p.drawText((margLeft+80)*scale,(temp_i_height+10+margTop)*scale,tr("Imi i nazwisko osoby upowanionej do wystawienia faktury VAT "));
      p.drawText((margLeft+430)*scale,(temp_i_height+10+margTop)*scale,tr("Imi i nazwisko osoby upowanionej do odbioru faktury VAT"));
#endif

#ifdef QF_vatmp__
      p.drawText((margLeft+80)*scale,(temp_i_height+10+margTop)*scale,tr("Imi i nazwisko osoby upowanionej do wystawienia faktury VAT "));
      p.drawText((margLeft+430)*scale,(temp_i_height+10+margTop)*scale,tr("Imi i nazwisko osoby upowanionej do odbioru faktury VAT"));

#endif

#ifdef QF_noVAT__
      p.drawText((margLeft+80)*scale,(temp_i_height+10+margTop)*scale,tr("Imi i nazwisko osoby upowanionej do wystawienia rachunku "));
      p.drawText((margLeft+430)*scale,(temp_i_height+10+margTop)*scale,tr("Imi i nazwisko osoby upowanionej do odbioru rachunku"));
#endif          
      

      
}


void PrintPreview::setVisibleColumn()
{
    QSettings settings;
    visibleColumns[0]=settings.readBoolEntry ("elinux/faktury_pozycje/Lp");
    visibleColumns[1]=settings.readBoolEntry ("elinux/faktury_pozycje/Nazwa");
    visibleColumns[2]=settings.readBoolEntry ("elinux/faktury_pozycje/Kod");
    visibleColumns[3]=settings.readBoolEntry ("elinux/faktury_pozycje/pkwiu");
    visibleColumns[4]=settings.readBoolEntry ("elinux/faktury_pozycje/ilosc");
    visibleColumns[5]=settings.readBoolEntry ("elinux/faktury_pozycje/jm");
    visibleColumns[6]=settings.readBoolEntry ("elinux/faktury_pozycje/cenajedn");
    visibleColumns[7]=settings.readBoolEntry ("elinux/faktury_pozycje/wartnetto");
    visibleColumns[8]=settings.readBoolEntry ("elinux/faktury_pozycje/rabatperc");
    visibleColumns[9]=settings.readBoolEntry ("elinux/faktury_pozycje/rabatval");
    visibleColumns[10]=settings.readBoolEntry ("elinux/faktury_pozycje/nettoafter");
    visibleColumns[11]=settings.readBoolEntry ("elinux/faktury_pozycje/vatval");
    visibleColumns[12]=settings.readBoolEntry ("elinux/faktury_pozycje/vatprice");
    visibleColumns[13]=settings.readBoolEntry ("elinux/faktury_pozycje/bruttoval");
    
    settings.beginGroup("elinux/wydruki");
    sizeColumns[0]=settings.readEntry("col1").toInt()*4;
    sizeColumns[1]=settings.readEntry("col2").toInt()*4;
    sizeColumns[2]=settings.readEntry("col3").toInt()*4;
    sizeColumns[3]=settings.readEntry("col4").toInt()*4;
    sizeColumns[4]=settings.readEntry("col5").toInt()*4;
    sizeColumns[5]=settings.readEntry("col6").toInt()*4;
    sizeColumns[6]=settings.readEntry("col7").toInt()*4;
    sizeColumns[7]=settings.readEntry("col8").toInt()*4;
    sizeColumns[8]=settings.readEntry("col9").toInt()*4;
    sizeColumns[9]=settings.readEntry("col10").toInt()*4;
    sizeColumns[10]=settings.readEntry("col11").toInt()*4;
    sizeColumns[11]=settings.readEntry("col12").toInt()*4;
    sizeColumns[12]=settings.readEntry("col13").toInt()*4;
    sizeColumns[13]=settings.readEntry("col14").toInt()*4;
    settings.endGroup();
  int temp=0;  
  leftColumns[0]=margLeft;
  for(int i=0;i<14;++i)
  {
      
    if(visibleColumns[i]==true)
      {
	temp+=sizeColumns[i];      
    }
    leftColumns[i+1]=temp+margLeft;
  }
  if((840-leftColumns[14]-margRight)>0)
  {
      for(int i=0;i<15;++i)
      {
	  leftColumns[i]+=((840-leftColumns[14]-margRight)/2);
      }
  }
}


void PrintPreview::exportJpg()
{

    int temp_i=0;
    bool ok=false,eXit=false;
    QString filename;
    QFileInfo filenameinfo;
    while(!ok)
    {
    while(filename=="")
	{
	filename=QFileDialog::getSaveFileName(QString::null,"*.png");
	if(filename=="")
	{
	    temp_i=QMessageBox::question(this, "QFaktury", tr("Czy chcesz anulowa? "),QMessageBox::Yes ,QMessageBox::No );
	if(temp_i==QMessageBox::Yes)
	   {
	    eXit=true;
	    break;
	}
                }
               }
    filenameinfo.setFile(filename);
    if((filenameinfo.extension()).upper()!="PNG")
        filename+=".png";    
    if(QFile::exists(filenameinfo.filePath()+"_01"+".png"))
    {	
	temp_i=QMessageBox::question(this, "QFaktury", tr("Czy chcesz nadpisa plik? "),QMessageBox::Yes ,QMessageBox::No );
	if(temp_i==QMessageBox::Yes)
	  {
	  ok=true;
                  }
    }
    else
    {
	ok=true;
    }
}
  if(eXit==false)
    {
      this->setCaption(tr("Trwa eksportowanie..."));
      for(unsigned int i=0;i<pixmap.size();++i)
        {
	  if(i<9)
	  {
	      if(QFile::exists(filenameinfo.filePath()+"_0"+QString::number(i+1)+".png"))
   	        QFile::remove(filenameinfo.filePath()+"_0"+QString::number(i+1)+".png");
	      pixmap[i].save(filenameinfo.filePath()+"_0"+QString::number(i+1)+".png","PNG");    	      
	  }
	  else

	  {
	    if(QFile::exists(filenameinfo.filePath()+"_"+QString::number(i+1)+".png"))
	      QFile::remove(filenameinfo.filePath()+"_"+QString::number(i+1)+".png");  
                    pixmap[i].save(filenameinfo.filePath()+"_"+QString::number(i+1)+".png","PNG");   	      
	  }
        }
    }
  this->setCaption(tabletemp.data.Title);      
    
}







void PrintPreview::destroy()
{
    //qDebug("destroy");
    delete label;
    delete view;
    pixmap.clear();
    pixmap_pdf.clear();
}


void PrintPreview::drawPrintSummary( QPainter &p, int count )
{
    QRect rect=p.viewport();
    p.drawLine(static_cast<int>((pageMargLeft)*xrate),rect.height()-static_cast<int>((20.0+pageMargDown)*yrate),static_cast<int>((840.0-pageMargRight)*xrate),rect.height()-static_cast<int>((20.0+pageMargDown)*yrate));
    QFont f=p.font();
    p.setFont(QFont("Times",static_cast<int>(8.0*yrate)));
    QString s(tr("QFaktury GPL wersja "));  
    s+=version;
    p.drawText(static_cast<int>((pageMargLeft+10.0)*xrate),rect.height()-static_cast<int>((10.0+pageMargDown)*yrate),s);
    p.drawText(static_cast<int>((640.0-pageMargRight)*xrate),rect.height()-static_cast<int>((10.0+pageMargDown)*yrate),tr("e-linux.pl"));
    p.drawText(static_cast<int>(380.0*xrate),rect.height()-static_cast<int>((10.0+pageMargDown)*yrate),tr("strona ")+QString::number(count+1)+"/"+QString::number(pixmap.size()));
    p.setFont(f);
}


void PrintPreview::printTransfer()
{
    int temp_i=0;
    bool ok=false,eXit=false;
    QString filename;
    QFileInfo filenameinfo;
    while(!ok)
    {
    while(filename=="")
	{
	filename=QFileDialog::getSaveFileName(QString::null,"*.png");
	if(filename=="")
	{
	    temp_i=QMessageBox::question(this, "QFaktury", tr("Czy chcesz anulowa? "),QMessageBox::Yes ,QMessageBox::No );
	if(temp_i==QMessageBox::Yes)
	   {
	    eXit=true;
	    break;
	}
                }
               }
    filenameinfo.setFile(filename);
    if((filenameinfo.extension()).upper()!="PNG")
        filename+=".png";    
    if(QFile::exists(filename))
    {	
	temp_i=QMessageBox::question(this, "QFaktury", tr("Czy chcesz nadpisa plik? "),QMessageBox::Yes ,QMessageBox::No );
	if(temp_i==QMessageBox::Yes)
	  {
	  QFile::remove(filename);
	  ok=true;
                  }
    }
    else
    {
	ok=true;
    }
}
  if(eXit==false)
    {
      this->setCaption(tr("Trwa eksportowanie..."));

      bool printOk=false;

   QPixmap p(getTransfer(printOk));   
   
   if(printOk==true)
       p.save(filename,"PNG");       
  this->setCaption(tabletemp.data.Title);      
  }

}


QPixmap PrintPreview::getTransfer(bool &printOk)

{
//    qDebug(tabletemp.data.client);
    QStringList qstringlist=QStringList::split(",",tabletemp.data.client);

    QPixmap pix(595,842);
    pix.fill();
    QPainter p(&pix);
   QString templDir;
    QDir abs (qApp->argv ()[0]);
  if (QString (qApp->argv ()[0]).left (2) == "./")
    templDir = abs.absPath ();
  else
    templDir = "/usr/bin/qfaktury";
 //   absPath();
    templDir = templDir.replace ("bin", "share");
    templDir = templDir + "/icons/";
    if(!QFile::exists(templDir+"standard.png"))
    {
	QMessageBox::information(this, "QFaktury", tr("Brak pliku standard.png!!!\n Brak moliwoci eksportu druku przelewu."),QMessageBox::Ok);	
	printOk=false;
	return NULL;
    }
    p.drawPixmap(0,0,QPixmap(templDir+"standard.png"));
    QSettings settings;
    QFont font ("Helvetica [Cronyx]", 12);
    p.setFont (font);
    p.rotate(270.0);
    p.translate(-842.0,0.0);
    drawTransferBody(p,0,0);
    drawTransferBody(p,0,1);
    drawTransferBody(p,1,0);
    drawTransferBody(p,1,1);
    printOk=true;
    return pix;       
}


void PrintPreview::drawTransferBody( QPainter &p, int x, int y )
{
    QSettings settings;
    p.drawText(x*387+55,y*283+38,settings.readEntry ("elinux/user/nazwa"));
    p.drawText(x*387+55,y*283+58,settings.readEntry ("elinux/user/adres")+" , "+settings.readEntry ("elinux/user/kod")+" "+settings.readEntry ("elinux/user/miejscowosc"));

    if(settings.readEntry ("elinux/user/konto").replace ("-","").length()==26)
    {
	QString temp=settings.readEntry ("elinux/user/konto").replace ("-","");
	for(unsigned int i=0;i<26;++i)
	      p.drawText(x*386+55+i*13, y*283+88, QString(temp[i]));
    }
    else
    {
	        QMessageBox::information (this, "QFaktury", tr("Niepoprawny numer konta uytkownika!!!"),QMessageBox::Ok);	
    }
    p.drawText(x*386+260, y*283+108, tabletemp.data.sum);
    p.drawText(x*386+70,y*283+133,tabletemp.data.sumStr);
    p.drawText(x*386+60,y*283+228,tr("Termin patnoci: ")+tabletemp.data.payDate);
			 
#ifdef QF_base__
    p.drawText(x*386+60,y*283+206,tr("Zapata za faktur ") + tabletemp.data.Number);
#endif

#ifdef QF_vatmp__
    p.drawText(x*386+60,y*283+206,tr("Zapata za faktur ") + tabletemp.data.Number);
#endif

#ifdef QF_noVAT__
    p.drawText(x*386+60,y*283+206,tr("Zapata za rachunek ") + tabletemp.data.Number);
#endif          
}


void PrintPreview::closeEvent( QCloseEvent * e )
{
    QSettings settings;
    settings.beginGroup ("elinux/formatki");
    settings.writeEntry ("printpreview_top",QString::number(this->y()));
    settings.writeEntry ("printpreview_left",QString::number(this->x()));
    settings.writeEntry ("printpreview_width",QString::number(this->width()));
    settings.writeEntry ("printpreview_height",QString::number(this->height()));
    settings.endGroup ();
    e->accept ();
}


void PrintPreview::resizeEvent( QResizeEvent * )
{
    view->setGeometry(0,0,frame4->width(),frame4->height());
    if(frame4->width()>840)
	view->moveChild(label,(frame4->width()-840)/2,0);
    else
	view->moveChild(label,0,0);
    
}
